#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include "action_external.h"
#include "player_pub.h"
#include "swf_file_pub.h"
#include "base_types.h"
#include "instance.h"
#include "movie_clips_ins.h"
#include "dynamic_text_def.h"
#include "dynamic_text_ins.h"
#include "dynamic_var.h"


extern player_t *player_p;

/*--------------------------------------------------------------------*/

int get_alpha(const char *name,double *value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (!node_p)
        return -1;
    *value = ins_get_alpha(node_p);
    fprintf(stdout,"\t\t get_alpha(name=%s)\n",name);
    return 0;
}

/*---------------------------------------------------------------------*/

int get_currentframe(const char *name,int *value) {
    fprintf(stdout,"\t\t get_currentframe(name=%s)\n",name);
    *value = 666;
    return 0;
};
/*----------------------------------------------------*/
int get_droptarget(const char *name,char *buff,size_t length) {
    fprintf(stdout,"\t\t get_droptarget(name=%s)\n",name);
    snprintf(buff,length,"%s","/droptarget1");
    return 0;
};
/*-----------------------------------------------------*/
int get_framesloaded(const char *name,int *value) {
    fprintf(stdout,"\t\t get_framesloaded(name=%s)\n",name);
    *value = player_p->_level0_p->frame_count;
    return 0;
}
/*-----------------------------------------------------*/

int get_height(const char *name,double *value) {
    fprintf(stdout,"\t\t get_height(name=%s)\n",name);
    *value = 663;
    return 0;
}

/*-----------------------------------------------------*/

char * get_name(const char *name) {
    static char tmp[]="get_name";
    fprintf(stdout,"\t\t get_name(name=%s)\n",name);
    return tmp;
}
/*----------------------------------------------------------*/

int get_rotation(const char *name,double * value ) {
    fprintf(stdout,"\t\t get_rotation(name=%s)\n",name);
    *value = 66.0;
    return 0;
}


char * get_target(const char *name,char *buff,size_t length) {

    fprintf(stdout,"\t\t get_target(name=%s)\n",name);
    snprintf(buff,length,"%s",name);
    return buff;
}
int get_totalframes(const char *name,int *value) {
    fprintf(stdout,"\t\t get_totalframes(name=%s)\n",name);
    *value = *value = player_p->_level0_p->frame_count;
    return 0;
}


char * get_url(const char *name,char *buff,size_t length) {
    fprintf(stdout,"\t\t get_url(name=%s)\n",name);

    snprintf(buff,length,"_level1.geturl_ret");
    return buff;
}
int get_visible(const char *name,int *value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\t get_visible(name=%s)\n",name);
    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (!node_p)
        return -1;
    *value = ((instance_t*)node_p->data)->visible;
    return 0;
}
int get_width(const char *name,double *value ) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    node_p = ins_name_to_node(swf_p->_root_p,name);
    *value = ins_get_width(node_p);
    fprintf(stdout,"\t\t get_width(name=%s) %f \n",name,*value);
    return 0;
}

int get_x(const char *name,double * value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\t get_x(name=%s)\n",name);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    *value = ins_get_x(node_p);
    return 0;
}
int get_xmouse(const char *name,int *value) {
    fprintf(stdout,"\t\t get_xmouse(name=%s)\n",name);
    *value = 66;
    return 0;
}
int get_xscale(const char *name,double *value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (!node_p)
        return -1;
    *value = ins_get_xscale(node_p);
    fprintf(stdout,"\t\t get_xscale(name=%s)\n",name);
    return 0;
}
int get_y(const char *name,double *value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\t get_y(name=%s)\n",name);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    *value = ins_get_y(node_p);
    return 0;
}
int get_ymouse(const char *name,int *value) {
    fprintf(stdout,"\t\t get_ymouse(name=%s)\n",name);
    *value = 66;
    return 0;
}
int get_yscale(const char *name,double *value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (!node_p)
        return -1;
    *value = ins_get_yscale(node_p);
    fprintf(stdout,"\t\t get_yscale(name=%s)\n",name);
    return 0;
}

int set_alpha(const char *name,const double value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (!node_p)
        return -1;
    ins_set_alpha(node_p,value);
    fprintf(stdout,"\t\t set_alpha(name=%s)\n",name);
    return 0;
}


int set_height(const char *name,const double value) {
    fprintf(stdout,"\t\t set_height(name=%s)\n",name);
    return 66;
}
int set_name(const char *name,const char *value) {
    fprintf(stdout,"\t\t set_name(name=%s)\n",name);
    return 66;
}

int set_rotation(const char *name,const double value) {
    fprintf(stdout,"\t\t set_rotation(name=%s)\n",name);
    return 66.0;
}



int set_visible(const char *name,const int value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\t set_visible(name=%s)\n",name);
    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (!node_p)
        return -1;
    ins_set_visible(node_p,value);
    return 0;
}



int set_width(const char *name,const double value) {
    fprintf(stdout,"\t\t set_width(name=%s)\n",name);
    return 66;
}
int set_x(const char *name,const double value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\t set_x(name=%s) %f\n",name,value);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    ins_set_x(node_p,value);
    return 0;
}

int set_xscale(const char *name,const double value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (!node_p)
        return -1;
    ins_set_xscale(node_p,value);
    fprintf(stdout,"\t\t set_xscale(name=%s,%f)\n",name,value);
    return 0;
}
int set_y(const char *name,const double value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\t set_y(name=%s)\n",name);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    ins_set_y(node_p,value);
    return 0;
}

int set_yscale(const char *name,const double value) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (!node_p)
        return -1;
    ins_set_xscale(node_p,value);
    fprintf(stdout,"\t\t set_yscale(name=%s,%f)\n",name,value);
    return 0;
}



/*---_------------------------------------------------*/
int get_focusrect() {

    return 1;
}
/*----------------------------------------------------*/
int get_highquality() {
    return 2;
}
/*----------------------------------------------------*/


char * get_quality() {
    static char name[]="MEDIUM";
    return name;
}

/*----------------------------------------------------*/

int get_soundbuftime() {
    return 118;
}


/*----------------------------------------------------*/

int set_focusrect(const int focus) {
    fprintf(stdout,"\t\tset_focusrect(%d)\n",focus);
    return 0;
}
/*----------------------------------------------------*/
int set_highquality(const int quality) {
    fprintf(stdout,"\t\tset_highquality(%d)\n",quality);
    return 0;
}
/*----------------------------------------------------*/
int set_quality(const char * quality) {
    fprintf(stdout,"\t\tset_quality(%s)\n",quality);
    return 0;
}

/*----------------------------------------------------*/

int set_soundbuftime(const int buftime) {
    fprintf(stdout,"\t\tset_soundbuftime(%d)\n",buftime);
    return 0;
}


/*----------------------------------------------------*/

int getAscii() {
    fprintf(stdout,"\t\tgetAscii\n");
    return 36;
}

/*----------------------------------------------------*/

int getCode() {
    return 16;
}
/*----------------------------------------------------*/


int getKeyStat(const int keycode) {
    fprintf(stdout,"\t\tgetKeyStat(%d)\n",keycode);
    return 0;
}


/*====================================================*/






int find_MovieClip_onPool(const char *name) {
    swf_file_t		*swf_p = player_p->_level0_p;
    GNode		*node_p;
    char		*p;

    printf("\t\tfind --%s--", name);
    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p)
        switch (((instance_t*)(node_p->data))->ins_type) {
        case INS_DTX:
            printf(" DTX found\n");
            return 128;
        case INS_MC:
        case INS_BTN:
            printf(" MC or BTN found\n");
            return 64;
        };

    assert(name);
    if (dvar_get_value(name)) {
        printf(" DTX var found\n");
        return 128;
    };

    printf(" not found\n");
    return 0;
}


int MouseObject_Show() {
    fprintf(stdout,"\t\t Call MouseObject_Show();\n");
    return 0;
}


int MouseObject_Hide() {
    fprintf(stdout,"\t\t Call MouseObject_Hide();\n");
    return 0;
}


/*================================================================*/

int set_ColorObject_Transform(const char * name,Transform * form) {
    int i=0;
    fprintf(stdout,"\t\tset_ColorObject_Transform(%s",name);
    for(i=0;i<8;i++) {
        fprintf(stdout,",%s=%d",form[i].name,form[i].value);
    }
    fprintf(stdout,")\n");
    return 0;
}



int get_ColorObject_Transform(const char * name,Transform * form) {
    int i=0;
    fprintf(stdout,"\t\tget_ColorObject_Transform(%s)\n",name);
    for(i=0;i<8;i++) {
        form[i].value=i;
    }
    return 0;
}

int set_ColorObject_RGB(const char *name,int32_t rgb) {
    fprintf(stdout,"\t\tset_ColorObject_RGB(%s,%x)\n",name,rgb);
    return 0;
}

int get_ColorObject_RGB(const char *name,int32_t *rgb) {
    if(rgb)
        *rgb=0x888888;
    fprintf(stdout,"\t\tset_ColorObject_RGB(%s,return %x)\n",name,*rgb);
    return 0;
}


int MovieClip_AttachMovie(const char * name, const char * symbolIdentifier,const char *newName,int32_t depth) {
    swf_file_t          *swf_p = player_p->_level0_p;
    int 		char_id = swf_sym_to_char_id(swf_p,symbolIdentifier);
    GNode		*node_p = NULL ;

    assert(char_id>=0);
    node_p = ins_name_to_node(swf_p->_root_p,name);

    mc_ins_attach(node_p,char_id,newName,depth);

    fprintf(stdout,"\t\tMovieClip_AttachMovie(name = %s, %s, %s, %d)\n",name,symbolIdentifier,newName,depth);
    return 0;
}

int MovieClip_DuplicateMovieClip(const char * name, const char *newName,int32_t depth) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = NULL ;

    fprintf(stdout,"\t\tMovieClip_DuplicateMovieClip(name = %s, %s, %d)\n",name,newName,depth);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    mc_ins_duplicate(node_p,newName,depth);
    return 0;
}

int MovieClip_GetBounds(const char *name,const char * target, int32_t *xMin, int32_t *xMax, int32_t *yMin, int32_t *yMax) {
    fprintf(stdout,"\t\tMovieClip_GetBounds(name = %s,%s %d, %d, %d, %d)\n",name,target,*xMin,*xMax,*yMin,*yMax);

    *xMin = 9;
    *xMax = 8;
    *yMin = 7;
    *yMax = 6;
    return 0;
}

int32_t MovieClip_GetBytesLoaded(const char *name) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = NULL ;
    long		loaded = 0;

    fprintf(stdout,"\t\tMovieClip_GetBytesLoaded(name = %s)\n",name);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p) {
        loaded = mc_ins_get_bytes_loaded(node_p);
        printf("loaded %d \n",loaded);
	return loaded;
    } else {
        return -1;
    };
}

int32_t MovieClip_GetBytesTotal(const char *name) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = NULL ;
    long		total = 0;

    fprintf(stdout,"\t\tMovieClip_GetBytesTotal(name = %s)\n",name);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p) {
        total = mc_ins_get_bytes_total(node_p);
        printf("total %d \n",total);
	return total;
    } else {
        return -1;
    };
}

int MovieClip_GetURL(const char *name,const char * url,const char * window,const char *method) {
    char *url_p = strdup(url);

    assert(pthread_mutex_lock(&player_p->urlq_mutex)==0);
    player_p->urlq_p=g_slist_append(player_p->urlq_p,url_p);
    pthread_cond_signal(&player_p->urlq_cond);
    assert(pthread_mutex_unlock(&player_p->urlq_mutex)==0);
    fprintf(stdout,"\t\tMovieClip_GetURL(name = %s, %s, %s, %s)\n",name,url,window,method);
    return 0;
}

int MovieClip_GlobalToLocal(const char *name,double *x,double *y) {
    fprintf(stdout,"\t\tMovieClip_GlobalToLocal(name = %s, %f, %f)\n",name,*x,*y);
    *x = 66.66;
    *y = 666.666;
    return 0;
}

int MovieClip_GotoAndPlay_Number(const char *name,int frameNumber) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;
    fprintf(stdout,"\t\tMovieClip_GotoAndPlay_Number(name = %s, %d)\n",name,frameNumber);
    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p) {
        mc_ins_go_and_play(node_p,frameNumber);
        return 0;
    } else {
        return -1;
    };
    return 0;
}

int MovieClip_GotoAndPlay_Label(const char *name,const char *frameLabel, const int Scene) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;
    int			frameNumber = -1;

    fprintf(stdout,"\t\tMovieClip_GotoAndPlay_Label(name = %s, %s, %d)\n",name,frameLabel,Scene);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    assert(node_p);
    frameNumber = mc_ins_label_find(node_p,frameLabel);
    assert(frameNumber>=0);
    if (node_p) {
        mc_ins_go_and_play(node_p,frameNumber);
        return 0;
    } else {
        return -1;
    };
    return 0;
}

int MovieClip_GotoAndStop_Number(const char *name,const int frameNumber) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\tMovieClip_GotoAndStop_Number(name = %s, %d)\n",name,frameNumber);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p) {
        mc_ins_go_and_stop(node_p,frameNumber);
        return 0;
    } else {
        return -1;
    };

}

int MovieClip_GotoAndStop_Label(const char *name,const char *frameLabel, const int Scene) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;
    int			frameNumber = -1;
    fprintf(stdout,"\t\tMovieClip_GotoAndStop_Label(name = %s, %s, %d)\n",name,frameLabel,Scene);
    node_p = ins_name_to_node(swf_p->_root_p,name);
    frameNumber = mc_ins_label_find(node_p,frameLabel);
    assert(frameNumber>=0);
    if (node_p) {
        mc_ins_go_and_stop(node_p,frameNumber);
        return 0;
    } else {
        return -1;
    };
    return 0;
}

int MovieClip_HitTest_by_Object(const char *name,const char *tmpstr) {
    fprintf(stdout,"\t\tMovieClip_HitTest_by_Object(name = %s, %s)\n",name,tmpstr);
    return 1;
}

int MovieClip_HitTest_by_Coordinate(const char *name,const int32_t x,const int32_t y,const int32_t shapeFlag) {
    fprintf(stdout,"\t\tMovieClip_HitTest_by_Coordinate(name = %s, %d, %d, %d)\n",name,x,y,shapeFlag);
    return 0;
}


int MovieClip_LoadMovie(const char *name, const char *url, const char *method) {
    fprintf(stdout,"\t\tMovieClip_LoadMovie(name = %s, %s, %s)\n",name,url,method);
    return 0;
}

int MovieClip_LoadVariables(const char *name,const char * url,const char *method) {
    fprintf(stdout,"\t\tMovieClip_LoadVariables(name = %s, %s, %s)\n",name,url,method);
    return 0;
}

int MovieClip_LocalToGlobal(const char *name,double *x,double *y) {
    fprintf(stdout,"\t\tMovieClip_LocalToGlobal(name = %s, %f, %f)\n",name,*x,*y);
    *x = 99.08;
    *y = 88.09;
    return 0;
}


int MovieClip_NextFrame(const char *name) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;
    fprintf(stdout,"\t\tMovieClip_NextFrame(name = %s)\n",name);
    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p) {
        mc_ins_next_frame(node_p);
        return 0;
    } else {
        return -1;
    };
    return 0;
}

int MovieClip_Play(const char *name) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\tMovieClip_Play(name = %s)\n",name);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p) {
        mc_ins_play(node_p);
        return 0;
    } else {
        return -1;
    };
}


int MovieClip_PrevFrame(const char *name) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\tMovieClip_PrevFrame(name = %s)\n",name);
    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p) {
        mc_ins_prev_frame(node_p);
        return 0;
    } else {
        return -1;
    };

    return 0;
}

int MovieClip_RemoveMovieClip(const char *name) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\tMovieClip_RemoveMovieClip(name = %s)\n",name);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p) {
        mc_ins_remove(node_p);
        return 0;
    } else {
        return -1;
    };

    return 0;
}





int MovieClip_StartDrag(const char *name, int lockCenter, int32_t left, int32_t top, int32_t right, int32_t bottom) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = NULL;

    node_p = ins_name_to_node(swf_p->_root_p,name);
    assert(node_p);
    drag_start(node_p);

    fprintf(stdout,"\t\tMovieClip_StartDrag_all(name = %s,%d,%d,%d,%d,%d)\n",name,lockCenter,left,top,right,bottom);
    return 0;
}




int MovieClip_Stop(const char *name) {
    swf_file_t          *swf_p = player_p->_level0_p;
    GNode		*node_p = swf_p->_root_p;

    fprintf(stdout,"\t\tMovieClip_Stop(name = %s)\n",name);

    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p) {
        mc_ins_stop(node_p);
        return 0;
    } else {
        return -1;
    };
}


int MovieClip_StopDrag(const char *name) {
    drag_stop();
    fprintf(stdout,"\t\tMovieClip_StopDrag(name = %s)\n",name);
    return 0;
}


int MovieClip_SwapDepths_by_depth(const char *name,int depth) {
    fprintf(stdout,"\t\tMovieClip_SwapDepths_by_depth(name = %s,%d)\n",name,depth);
    return 0;
}


int MovieClip_SwapDepths_by_target(const char *name,const char *target) {
    fprintf(stdout,"\t\tMovieClip_SwapDepths_by_target(name = %s,%s)\n",name,target);
    return 0;
}

int MovieClip_UnloadMovie(const char *name) {
    fprintf(stdout,"\t\tMovieClip_UnloadMovie(name = %s)\n",name);
    return 0;
}

/*================================================================*/

int MovieClip_Print(const char *target,const char *boundingBox) {
    fprintf(stdout,"\t\tMovieClip_Print(name = %s,%s)\n",target,boundingBox);
    return 0;
}

int MovieClip_Fscommand(const char *command,const char * arguments) {
    fprintf(stdout,"\t\tMovieClip_Fscommand(name = %s,%s)\n",command,arguments);
    return 0;
}

int32_t MovieClip_GetTimer() {
    fprintf(stdout,"\t\tMovieClip_GetTimer()\n");
    return 6667;
}
int MovieClip_NextScene(const char *name) {
    fprintf(stdout,"\t\tMovieClip_NextScene(name = %s)\n",name);
    return 0;
}

int MovieClip_PrevScene(const char *name) {
    fprintf(stdout,"\t\tMovieClip_PrevScene(name = %s)\n",name);
    return 0;
}

int MovieClip_PrintAsBitmap(const char *target,const char *boundingBox) {
    fprintf(stdout,"\t\tMovieClip_PrintAsBitmap(name = %s,%s)\n",target,boundingBox);
    return 0;
}

int MovieClip_PrintAsBitmapNum(const char *target,const char *boundingBox) {
    fprintf(stdout,"\t\tMovieClip_PrintAsBitmapNum(name = %s,%s)\n",target,boundingBox);
    return 0;
}



int MovieClip_PrintNum(const char * cname,const char * boundingBox) {
    fprintf(stdout,"\t\tMovieClip_PrintNum(name = %s,%s)\n",cname,boundingBox);
    return 0;
}

int MovieClip_StopAllSounds() {
    fprintf(stdout,"\t\tMovieClip_StopAllSounds()\n");
    return 0;
}

int MovieClip_toggleHighQuality() {
    fprintf(stdout,"\t\tMovieClip_toggleHighQuality()\n");
    return 0;
}

int MovieClip_UpdateAfterEvent() {
    fprintf(stdout,"\t\tMovieClip_UpdateAfterEvent()\n");
    return 0;
}



int  MovieClip_Call_Number(const char * target ,int framenum,unsigned char**framecode,int *codelen) {
    static uint8_t b[2]={0,0};
    fprintf(stdout,"\t\tMovieClip_Call_Num(%s,%d)\n",target,framenum);
    if(framecode)
        *framecode = (unsigned char *)b;
    if(codelen)
        *codelen = sizeof(b);
    return 0;
}


int MovieClip_Call_Label(const char *target,const char *framename,unsigned char  **framecode,int *codelen) {
    static uint8_t b[2]={0,0};
    fprintf(stdout,"\t\tMovieClip_Call_Label(%s,%s)\n",target,framename);
    if(framecode)
        *framecode = (unsigned char *)b;
    if(codelen)
        *codelen = sizeof(b);

    return 0;
}


// δ 0,  1,
int MovieClip_IfFrameLoaded_Label(const char *target,const char *framename) {
    fprintf(stdout,"\t\tMovieClip_IfFrameLoaded_Label(%s,%s)\n",target,framename);
    return 1;
}

int MovieClip_IfFrameLoaded_Number(const char *target,int frameNum) {
    fprintf(stdout,"\t\tMovieClip_IfFrameLoaded_Number(%s,%d)\n",target,frameNum);
    return 1;
}




/*============================================================*/


int SoundObject_AttachSound(const char *pname,const char *soundname) {
    fprintf(stdout,"\t\tSoundObject_AttachSound(name=%s,%s)\n",pname,soundname);
    return 0;
}

int SoundObject_GetPan(const char *pname) {
    fprintf(stdout,"\t\tSoundObject_GetPan(name=%s)\n",pname);
    return 18;
}


int SoundObject_GetTransform(const char *pname,Transform * form) {
    int i=0;
    fprintf(stdout,"\t\tSoundObject_Transform(%s)\n",pname);
    for(i=0;i<4;i++) {
        form[i].value=i*8;
    }
    return 0;
}


int SoundObject_GetVolume(const char *pname) {
    fprintf(stdout,"\t\tSoundObject_GetVolume(name=%s)\n",pname);
    return 88;
}


int SoundObject_SetPan(const char *pname,int equilibria) {
    fprintf(stdout,"\t\tSoundObject_SetPan(name=%s,%d)\n",pname,equilibria);
    return 0;
}


int SoundObject_SetTransform(const char *pname,Transform * form) {
    int i=0;
    fprintf(stdout,"\t\tSetTransform_Transform(%s",pname);
    for(i=0;i<4;i++) {
        fprintf(stdout,",%s=%d",form[i].name,form[i].value);
    }
    fprintf(stdout,")\n");
    return 0;
}


int SoundObject_SetVolume(const char *pname,int volume) {
    fprintf(stdout,"\t\tSoundObject_SetVolume(name=%s,%d)\n",pname,volume);
    return 0;
}


int SoundObject_Start(const char *pname,double secondOffset,int loops) {
    fprintf(stdout,"\t\tSoundObject_Start(name=%s,%f,%d)\n",pname,secondOffset,loops);
    return 0;
}


int SoundObject_Stop(const char *pname,const char *soundname) {
    fprintf(stdout,"\t\tSoundObject_Stop(name=%s,%s)\n",pname,soundname);
    return 0;
}
int SoundObject_GetPosition(const char *name) {
    fprintf(stderr,"\t\tSoundObject_GetPosition(name=%s)\n",name);
    return 100;
}

char *SoundObject_GetId3(const char *name) {
    fprintf(stderr,"\t\tSoundObject_GetId3(name=%s)\n",name);
    return "COMM";
}

int SoundObject_GetDuration(const char *name) {
    fprintf(stderr,"\t\tSoundObject_GetDuration(name=%s)\n",name);
    return 101;
}





/*==================================================================*/



int SelectionObject_GetBeginIndex() {
    fprintf(stdout,"\t\tGetBeginIndex()\n");
    return 108;
}

int SelectionObject_GetCaretIndex() {
    fprintf(stdout,"\t\tGetCaretIndex()\n");
    return 106;
}

int SelectionObject_GetEndIndex() {
    fprintf(stdout,"\t\tGetEndIndex()\n");
    return 106;
}

int SelectionObject_GetFocus(char * focus,const int len) /* value-result function*/
{
    fprintf(stdout,"\t\tGetFocus()\n");
    if(focus && len > 0)
        snprintf(focus,len,"_root.test_getfocus");
    return 0;
}

int SelectionObject_Setfocus(const char *focus) {
    fprintf(stdout,"\t\tSetFocus(%s)\n",focus);
    return 0;
}

int SelectionObject_SetSelection(int beginIndex,int endIndex) {
    fprintf(stdout,"\t\tSetSelection(%d,%d)\n",beginIndex,endIndex);
    return 0;
}

/*=================================================================*/

int find_TextField_onPool(const char *name) {
    GNode	*node_p;
    swf_file_t		*swf_p = player_p->_level0_p;

    assert(0);
    node_p = ins_name_to_node(swf_p->_root_p,name);
    if (node_p && (((instance_t*)(node_p->data))->ins_type == INS_DTX))
        return 1;
    else
        return 0;
}



int TextField_GetScroll(const char *name,int *value,int flags) {
    fprintf(stdout,"\t\tTextField_GetScroll(%s,%d)\n",name,flags);
    if(value)
        *value = 999;
    return 0;
}


int TextField_GetMaxScroll(const char *name,int *value,int flags) {
    fprintf(stdout,"\t\tTextField_GetMaxScroll(%s,%d)\n",name,flags);
    if(value)
        *value = 9888;
    return 0;
}



int TextField_SetScroll(const char *name,const int val,int flags) {
    fprintf(stdout,"\t\tTextField_SetScroll(%s,%d,%d)\n",name,val,flags);
    return 0;
}


int TextField_SetMaxScroll(const char *name,const int val,int flags) {

    fprintf(stdout,"\t\tTextField_SeMaxScroll(%s,%d,%d)\n",name,val,flags);
    return 0;
}

char *TextField_GetBuffer(const char *name) {
    swf_file_t		*swf_p = player_p->_level0_p;
    char		*value_str;
    fprintf(stderr,"\nTextField_GetBuffer(%s)\n",name);

    assert(name);
    value_str = dvar_get_value(name);
    fprintf(stdout,"\t\tTextField_GetBuffer(%s)\n",name);
    assert(value_str);
    return value_str;
}

int TextField_SetBuffer(const char *name,const char *buffer) {
    GNode		*node_p;
    swf_file_t		*swf_p = player_p->_level0_p;
    dtx_ins_t		*data_p = NULL;
    char		*value_p = NULL;

    assert(name);
    value_p = dvar_get_value(name);
	dvar_set_value(name,buffer);

    fprintf(stdout,"\t\tTextField_SetBuffer(%s,%s)\n",name,buffer);
    node_p = dtx_var_name_to_node(swf_p->_root_p,name);
    //    assert(node_p!=0);
    if (node_p) {
        data_p = (dtx_ins_t*)(node_p->data);
        printf("dtx name %s\n",data_p->name_p);
        dtx_update_shape(node_p);
        data_p->dirty = TRUE;
    }
    return 0;
}

/*==============================================================*/


int Get_rootname_onPool(char * buffer,size_t len) {
    char *name = "_level0";
    fprintf(stdout,"\t\tGet_rootname_onPool buffer length=%d\n",len);
    if(!buffer || len < strlen(name))
        return (strlen(name)+1);
    snprintf(buffer,len,"%s",name);
    return 0;
}


/*==============================================================*/

int MovieClip_GetVersion() {
    swf_file_t		*swf_p = player_p->_level0_p;
    return swf_p->version;
}

/*==============================================================*/

int MovieClip_FindLabel(const char *target,const char *label){
	fprintf(stdout,"\nMovieClip_FindLabel(%s,%s)",target?target:"NULL",label?label:"NULL");
	return -1;		//	-1	occur error or not found
}
