#include "base_types.h"
#include "config.h"
#include "define.h"
#include "movie_clips_def.h"
#include "swf_file_pub.h"
#include "dynamic_text_def.h"
#include "static_text_def.h"
#include "dynamic_text_ins.h"
#include "swf_file_pub.h"
#include "instance.h"
#include "font_def.h"
#include "dynamic_var.h"
#include "matrix.h"
#include <glib.h>

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <wchar.h>
#include <stdlib.h>
#include <sys/types.h>
#include <iconv.h>

#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_GLYPH_H
#include FT_OUTLINE_H
#include FT_BBOX_H
#include <assert.h>
#if WITH_DMALLOC
#include <dmalloc.h>
#endif

//#define PRINT_DG
#define OUTLEN 1024

struct Globle_Var {
    uint32_t tmpCode[OUTLEN];
    double scale ;
    int Gx ;
    int Gy ;
    int yAxis ;
    int   *Gadvance;
    int MyNum ;
    int Mytmp ;

    struct ShapeRecord	*headRec,*endRec;
    struct ShapeRecord	**MyRecA;
    struct DefineText GlobleText;
} ;

/*  from this function,we can call FT_Outline_Decompose function to get the glyph shape
 *  the func call four funcs such as handle_move_to,handle_line_to,handle_conic_to,handle_cubic_to
 */
void draw_outline (FT_OutlineGlyph glyph,struct Globle_Var *Globle_VarP);
// translate the size to EM size
double floatify (FT_Pos x,struct Globle_Var *Globle_VarP);
// get the glyph move to point and sign it to the globle shape record
int handle_move_to (FT_Vector *to, void *user);
// get the glyph line to point and sign it to the globle shape record
int handle_line_to (FT_Vector *to, void *user);
// get the glyph conic to point and sign it to the globle shape record
int handle_conic_to (FT_Vector *control, FT_Vector *to, void *user);
// get the glyph cubic to point and trans it to conic point then sign it to the globle shape record
int handle_cubic_to (FT_Vector *control1, FT_Vector *control2, FT_Vector *to,
                     void *user);
// init the Gloable MyRecord Array to save the Edit Text record
void initMyRecA(struct Globle_Var *Globle_VarP);
// delete the Gloable MyRecord Array to free space
void freeMyRecA(struct Globle_Var *Globle_VarP);
// init the temp record
void initRec(struct Globle_Var *Globle_VarP);
//void freeRec(struct Globle_Var *Globle_VarP);
void freeDefineText(struct DefineText *data);
void freeDefineShape(struct DefineShape *data);
void freeFillStyle(struct FillStyle *data);

//get the bounds shape record
int getTextBounds(GNode* node_p,struct TextRecord *outRecordP);
//get the cursor shape record
int getCursor(GNode* node_p,struct TextRecord *outRecordP,long x,long y);
//draw the bounds and cursor shape record
int drawTextBounds(GNode* node_p,struct Globle_Var *Globle_VarP);
//when the input string is HTML,decompose it and get the body string
int DecomposeHTML(char *str);
/*
 *	use iconv func to translate the charactor code from UTF-8 to UTF-32
 */
int code_convert(char *from_charset,char *to_charset,char *inbuf,int inlen,char *outbuf,int outlen);
/*
 *	according to the input string, use the simsun font, find out the right glyph shape record
 *	then save them to the globle shape record as device glyph shape.
 */
int FontToShape(GNode* node_p,struct Globle_Var *Globle_VarP);
//int TextToShape(struct DefineEditText* intext,struct ShapeRecord* outText);
//deal with glyph font
int EmbedtoShape(GNode* node_p,struct Globle_Var *Globle_VarP);
//deal with device text shape record array
int DevicetoShape(GNode* node_p,struct Globle_Var *Globle_VarP);

void PrnShapeRec(struct ShapeRecord* mc) {
    struct ShapeRecord	*tmp;
    struct StraightEdgeRecord *SER;
    struct CurvedEdgeRecord *CER;
    struct StyleChangeRecord   *SCR;

    while(mc) {
        if(mc->Flags&StateMoveTo) {
            SCR = (struct StyleChangeRecord   *)mc;
            printf("the Shape Change Record -----Flags is %d\n",SCR->Flags);
            printf("the Shape Change Record -----MoveDeltaX is %ld\n",SCR->MoveDeltaX);
            printf("the Shape Change Record -----MoveDeltaY is %ld\n",SCR->MoveDeltaY);
            printf("the Shape Change Record -----FillStyle0 is %ld\n",SCR->FillStyle0);
            printf("the Shape Change Record -----FillStyle1 is %ld\n",SCR->FillStyle1);
            printf("the Shape Change Record -----LineStyle is %ld\n",SCR->LineStyle);
            printf("the Shape Change Record -----FillStylesP is %p\n",SCR->FillStylesP);
            printf("the Shape Change Record -----LineStylesP is %p\n",SCR->LineStylesP);
            printf("the Shape Change Record -----NumFillBits is %ld\n",SCR->NumFillBits);
            printf("the Shape Change Record -----NumLineBits is %ld\n",SCR->NumLineBits);
        }
        if(mc->Flags==TStraightEdge) {
            SER = (struct StraightEdgeRecord *)mc;
            printf("the Shape StraightEdge Record -----Flags is %d\n",SER->Flags);
            printf("the Shape StraightEdge Record -----StraightLineFlag is %d\n",SER->StraightLineFlag);
            printf("the Shape StraightEdge Record -----StraightLineDeltaX is %ld\n",SER->StraightLineDeltaX);
            printf("the Shape StraightEdge Record -----StraightLineDeltaY is %ld\n",SER->StraightLineDeltaY);
            printf("the Shape StraightEdge Record -----VertLineFlag is %d\n",SER->VertLineFlag);
            printf("the Shape StraightEdge Record -----HorLineDeltaX is %ld\n",SER->HorLineDeltaX);
            printf("the Shape StraightEdge Record -----VertLineDeltaY is %ld\n",SER->VertLineDeltaY);
        }
        if(mc->Flags==TCurvedEdge) {
            CER = (struct CurvedEdgeRecord *)mc;
            printf("the Shape CurvedEdge Record -----Flags is %d\n",CER->Flags);
            printf("the Shape CurvedEdge Record -----ControlDeltaX is %ld\n",CER->ControlDeltaX);
            printf("the Shape CurvedEdge Record -----ControlDeltaY is %ld\n",CER->ControlDeltaY);
            printf("the Shape CurvedEdge Record -----AnchorDeltaX is %ld\n",CER->AnchorDeltaX);
            printf("the Shape CurvedEdge Record -----AnchorDeltaY is %ld\n",CER->AnchorDeltaY);
        }
        tmp = mc;
        mc = tmp->NextP;
    }
}
void PrnTextRecord(struct TextRecord* mc) {
    struct TextRecord *tmp;
    int i;
    while(mc) {
        tmp = mc;
        printf("the TextRecord Record -----GlyphCount is %d\n",mc->GlyphCount);
        printf("the TextRecord Record -----GlyphEntries is %p\n",mc->GlyphEntries);
        for(i=0; i<mc->GlyphCount; i++) {
            printf("------------------------------------the TextRecord Record -----number is %d\n",i);
            PrnShapeRec(mc->GlyphEntries[i].Shape.ShapeRecordsP);
        }
        mc = tmp->NextP;
    }
}
void PrnDefineText(struct DefineText* mc) {
    printf("the DefineText Record -----CharacterType is %d\n",mc->CharacterType);
    printf("the DefineText Record -----CharacterID is %d\n",mc->CharacterID);
    printf("the DefineText Record -----TextRecordsP is %p\n",mc->TextRecordsP);
    PrnTextRecord(mc->TextRecordsP);
}
void dtx_ins_change(GNode* node_p,struct PlaceObject *cmd_p) {
    //	dtx_ins_t    *data_p   = (dtx_ins_t*)(node_p->data);
#ifdef PRINT_DG
    fprintf(stderr,"=============dtx_ins_change start============\n");
#endif

    dtx_update_shape(node_p);
#ifdef PRINT_DG
    fprintf(stderr,"=============dtx_ins_change end============\n");
#endif
}

static GNode *dtx_var_name_to_node_do(GNode* node_p,char** name_ary_p,int depth) {
    GNode *child = node_p;
    char  *name_p = name_ary_p[depth];

    if (name_ary_p[depth+1] == NULL) {
        while (child) {
            if ( (((dtx_ins_t*)(child->data))->ins_type == INS_DTX)
                    && (((dtx_ins_t*)(child->data))->var_name_p != NULL)) {
                if (g_strcasecmp(((dtx_ins_t*)(child->data))->var_name_p,name_p)==0) {
                    return child;
                };
            };
            child = child->next;
        };
        return 0;
    } else {
        while (child) {
            if (((instance_t*)(child->data))->name_p != NULL) {
                if (g_strcasecmp(((instance_t*)(child->data))->name_p,name_p)==0) {
                    return dtx_var_name_to_node_do(g_node_first_child(child),name_ary_p,depth+1);
                };
            };
            child = child->next;
        };
        return 0;
    };
};

#define MAX_DEPTH 20
GNode* dtx_var_name_to_node(GNode* node_p,const char* name_p) {
    char	**str_array;
    GNode	*p = NULL;

    str_array = g_strsplit(name_p,".",MAX_DEPTH);

    p = dtx_var_name_to_node_do(node_p,str_array,0);
    g_strfreev(str_array);
    return p;
};

char* dtx_get_var_full_name(GNode* node_p) {
    dtx_ins_t 	*data_p = (dtx_ins_t*)(node_p->data);
    GNode* p;
    char  *n1_p = NULL , *n2_p = NULL;
    char  *orig_name_p;

    orig_name_p = data_p->name_p;
    data_p->name_p = data_p->var_name_p;

    p = node_p;
    while (p) {
        n2_p = g_strjoin(".",((dtx_ins_t*)(p->data))->name_p,n1_p,NULL);
        if (n1_p)
            free(n1_p);
        n1_p = n2_p;
        p = p->parent;
    }

    data_p->name_p = orig_name_p;
    return n2_p;
};

/*
 * input DefineEditText ,according to it's flags to judge weather to use embeded font or device font.
 * then translate to DefineText ,draw the shape to it and put out
 * when the flag has EditTextUseOutlines ,then use glyph font ,otherwise use device font
 */
void dtx_update_shape(GNode* node_p) {
    dtx_ins_t    *data_p   = (dtx_ins_t*)(node_p->data);
//    swf_file_t    *swf_p   = data_p->swf_p;
    struct Globle_Var *Globle_VarP;
    struct DefineText *tmpText;

    data_p->value_p = (STRING)dvar_get_value(data_p->var_full_name_p);
#ifdef PRINT_DG
    fprintf(stderr,"value %s \n",data_p->value_p);
#endif

    if(data_p->define_p->Flags&EditTextUseOutlines) {}
    else {
        freeDefineText(data_p->text_p);
    }
    free(data_p->text_p);
    data_p->text_p = NULL;
    //printf("\n --------------------------data_p->value_p  is : %s \n",data_p->value_p);

    Globle_VarP = (struct Globle_Var *)malloc(sizeof(struct Globle_Var));
    bzero((void *)(Globle_VarP),sizeof(struct Globle_Var));
    Globle_VarP->yAxis = -1;

    tmpText = (struct DefineText *)malloc(sizeof(struct DefineText ));
    bzero((void *)(tmpText),sizeof(struct DefineText));
    data_p->text_p =tmpText;

	drawTextBounds((GNode*)node_p,Globle_VarP);
	
    if(data_p->define_p->Flags&EditTextUseOutlines) {
#ifdef PRINT_DG
    fprintf(stderr,"=============EmbedtoShape============\n");
#endif
        EmbedtoShape((GNode*)node_p,Globle_VarP);
    } else {
        if(data_p->define_p->Flags&EditTextHTML) {}
        else {
#ifdef PRINT_DG
    fprintf(stderr,"=============DevicetoShape============\n");
#endif
            FontToShape((GNode*)node_p,Globle_VarP);
            DevicetoShape((GNode*)node_p,Globle_VarP);
        }
    }

    Globle_VarP->GlobleText.CharacterType = CharText;
    Globle_VarP->GlobleText.TextBounds = data_p->define_p->Bounds;
    Globle_VarP->GlobleText.GlyphBits = 0;
    Globle_VarP->GlobleText.AdvanceBits = 0;
    //	data_p->shape->CharacterType  = CharText;
    //	data_p->shape->TextBounds = data_p->define_p->Bounds;
    //	data_p->shape->GlyphBits = 0;
    //	data_p->shape->AdvanceBits = 0;
    //	PrnDefineText(&Globle_VarP->GlobleText);
    *data_p->text_p = Globle_VarP->GlobleText;
    free(Globle_VarP);
    //printf("-----------------data_p->shape  is : %p \n",data_p->shape );
}
int EmbedtoShape(GNode* node_p,struct Globle_Var *Globle_VarP) {

    struct  DefineFont *Font;
    struct TextRecord *headTextRecordP,*endTextRecordP;
    struct TextRecord *TextRecordP;
    struct TextRecord *tmpHeadTextRecordP;
//    struct TextRecord *TextBoundP;
    struct TextRecord *CursorP;
    //    struct ShapeArray *p;
    struct Matrix TextMatrix;
    struct Matrix FontMatrix;
    long x,y;

    int CurPos =0;
    long CurX,CurY;
    int showCur = 1;

    int row = 0,rownum = 0;
    long Textlen = 0;
    long *TextAlign;
    long FontHeight=0;
    UI16                MaxLength =0;

    char*         src_str;
    unsigned	char out[OUTLEN];
    int rc;
    int i =0,j=0,outlen =OUTLEN ;
    uint32_t code[OUTLEN];
    int n =0,num=0;
    struct GlyphEntry *g_p ;
    struct  DefineEditText *Text;
    dtx_ins_t    *data_p   = (dtx_ins_t*)(node_p->data);

    x=y=0;
	showCur = data_p->focusd;
    src_str = data_p->value_p;
    Text = data_p->define_p;
    if (!src_str) {
//        Globle_VarP->GlobleText.TextRecordsP = NULL;
        return 0;
    }

    rc = code_convert("utf-8","utf-32",src_str,strlen(src_str),out,outlen);
    if(rc == 0) {
        for(i=0,j=0;;i=i+4,j++) {
            if(out[i]=='\0'&&out[i+1]=='\0'&&out[i+2]=='\0'&&out[i+3]=='\0')
                break;
            if(i+4>OUTLEN)
                break;
            code[j] = out[i]<<24|out[i+1]<<16 |out[i+2]<<8|out[i+3];
        }
    } else {
//        Globle_VarP->GlobleText.TextRecordsP = NULL;
        return 0;
    }

    if (j==0) {
//        Globle_VarP->GlobleText.TextRecordsP = NULL;
        return 0;
    }

    Font = (struct  DefineFont *)data_p->swf_p->dict_p->dict[Text->FontID];
    if(Text->Flags&EditTextHasMaxLength)
        MaxLength = Text->MaxLength;

    headTextRecordP = NULL;
    endTextRecordP = NULL;

    num = 0;
    for(i=1;i<j;i++) {
        if(Text->Flags&EditTextHasMaxLength) {
            if(i > MaxLength)
                break;
        }
        for(n=0;n<Font->NumGlyphs;n++) {
            if(code[i]==Font->GlyphShape[n].Code) {
                num++;
                break;
            }
        }
    }

    bzero((void *)(&TextMatrix),sizeof(struct Matrix));
    MatrixPrepare(&TextMatrix);
    bzero((void *)(&FontMatrix),sizeof(struct Matrix));

    FontHeight=Text->FontHeight;
    FontMatrix.HasScale=1;
    FontMatrix.ScaleX=FontHeight/1024.0;
    FontMatrix.ScaleY=FontHeight/1024.0;

    TextRecordP = (struct TextRecord*)malloc(sizeof(struct TextRecord)+(num-1)*sizeof(struct GlyphEntry));
    bzero((void *)TextRecordP,sizeof(struct TextRecord)+(num-1)*sizeof(struct GlyphEntry));
    TextRecordP->Flags =StyleFlagsHasColor;
    TextRecordP->FontID =Text->FontID;
    TextRecordP->TextColor = Text->TextColor;
    TextRecordP->TextHeight = Text->FontHeight;
    TextRecordP->GlyphCount = num;

    //get text rows
    for(i=1;i<j;i++) {
        if(Text->Flags&EditTextHasMaxLength) {
            if(i > MaxLength)
                break;
        }
        if(Text->Flags&EditTextMultiline) {
            if(code[i]=='\r') {
                x=0;
                rownum++;
            }
        }
        if(Text->Flags&EditTextWordWrap)
            if((x+Font->GlyphShape[n].FontAdvance*(FontMatrix.ScaleX))>Text->Bounds.Xmax) {
                x=0;
                rownum++;
            }
        for(n=0;n<Font->NumGlyphs;n++) {
            if(code[i]==Font->GlyphShape[n].Code) {
                x+=Font->GlyphShape[n].FontAdvance*(FontMatrix.ScaleX);
                break;
            }
        }
    }
    TextAlign = (long *)malloc(sizeof(long)*(rownum+1));
    bzero((void*)TextAlign,sizeof(long)*(rownum+1));
    TextAlign[0] = 0;
    row = 0;
    if(Text->Flags&EditTextHasLayout) {
        for(i=1;i<j;i++) {
            if(Text->Flags&EditTextHasMaxLength) {
                if(i > MaxLength)
                    break;
            }
            switch(Text->Align) {
            case 0:
                TextAlign[row] = 0;
                break;
            case 1:
                TextAlign[row] = Text->Bounds.Xmax - Textlen - Font->GlyphShape[n].FontAdvance*(FontMatrix.ScaleX)*0.5;
                break;
            case 2:
                TextAlign[row] = (Text->Bounds.Xmax - Textlen)/2;
                break;
            case 3:
                TextAlign[row] = 0;
                break;
            }
            if(Text->Flags&EditTextMultiline) {
                if(code[i]=='\r') {
                    Textlen = 0;
                    row++;
                }
            }
            if(Text->Flags&EditTextWordWrap)
                if((Textlen+Font->GlyphShape[n].FontAdvance*(FontMatrix.ScaleX))>Text->Bounds.Xmax) {
                    Textlen = 0;
                    row++;
                }
            for(n=0;n<Font->NumGlyphs;n++) {
                if(code[i]==Font->GlyphShape[n].Code) {
                    Textlen+=Font->GlyphShape[n].FontAdvance*(FontMatrix.ScaleX);
                    break;
                }
            }
        }
    }
    switch(Text->Align) {
    case 0:
        TextAlign[row] = 0;
        break;
    case 1:
        TextAlign[row] = Text->Bounds.Xmax - Textlen - Font->GlyphShape[n].FontAdvance*(FontMatrix.ScaleX)*0.5;
        break;
    case 2:
        TextAlign[row] = (Text->Bounds.Xmax - Textlen)/2;
        break;
    case 3:
        TextAlign[row] = 0;
        break;
    }
    num = 0;
    row = 0;
    y=Text->FontHeight;
    x=TextAlign[row];

    CurPos = i+1;
    CurY=Text->FontHeight;
    CurX=TextAlign[row];

    for(i=1;i<j;i++) {
        if(Text->Flags&EditTextHasMaxLength) {
            if(i > MaxLength)
                break;
        }
        if(Text->Flags&EditTextMultiline) {
            if(code[i]=='\r') {
                row++;
                x=TextAlign[row];
                y+=Text->FontHeight;
                if(i<CurPos) {
                    CurY+=Text->FontHeight;
                    CurX=TextAlign[row];
                }
            }
        }
        if(Text->Flags&EditTextWordWrap)
            if((x+Font->GlyphShape[n].FontAdvance*(FontMatrix.ScaleX))>Text->Bounds.Xmax) {
                row++;
                x=TextAlign[row];
                y+=Text->FontHeight;
                if(i<CurPos) {
                    CurY+=Text->FontHeight;
                    CurX=TextAlign[row];
                }
            }
        for(n=0;n<Font->NumGlyphs;n++) {
            if(code[i]==Font->GlyphShape[n].Code) {
                g_p = &(TextRecordP->GlyphEntries[num]);
                //printf("--------------the TextRecordP->GlyphEntries[%d] is %p \n",num,g_p);
                mat_new(&(g_p->GlyphMatrix));
                g_p->GlyphMatrix.TranslateX	= x;
                g_p->GlyphMatrix.TranslateY	= y;
                g_p->GlyphMatrix.ScaleX	= FontHeight/1024.0;
                g_p->GlyphMatrix.ScaleY	= FontHeight/1024.0;

                g_p->Shape.CharacterType	= CharShape;
                g_p->Shape.ShapeBounds	= Font->GlyphShape[n].FontBounds;
                //				p->TextShapes[num].Shape.ShapeBounds=Text->Bounds;
                g_p->Shape.ShapeRecordsP	= Font->GlyphShape[n].ShapeRecordP;
                x+=Font->GlyphShape[n].FontAdvance*(FontMatrix.ScaleX);
                if(i<CurPos) {
                    CurX+=Font->GlyphShape[n].FontAdvance*(FontMatrix.ScaleX);
                }
                num++;
                break;
            }
        }

    }
    //	TextRecordP->ShapesP=p;
    headTextRecordP = TextRecordP;
    TextRecordP->NextP = NULL;
    endTextRecordP = TextRecordP;
/*
    if(Text->Flags&EditTextBorder) {
        TextBoundP = (struct TextRecord*)malloc(sizeof(struct TextRecord));
        bzero((void *)TextBoundP,(sizeof(struct TextRecord)));
        TextBoundP->Flags =StyleFlagsHasColor;
        TextBoundP->FontID =Text->FontID;
        TextBoundP->TextColor = Text->TextColor;
        TextBoundP->TextHeight = Text->FontHeight;
        TextBoundP->GlyphCount = 1;
		TextBoundP->GlyphEntries[0].Shape.FillStylesP = NULL;
		TextBoundP->GlyphEntries[0].Shape.LineStylesP = NULL;
        getTextBounds(node_p,TextBoundP);
        TextBoundP->NextP = NULL;
        endTextRecordP->NextP = TextBoundP;
        endTextRecordP = TextBoundP;
    }
*/
    if(showCur) {
        showCur = 0;
        CursorP = (struct TextRecord*)malloc(sizeof(struct TextRecord));
        bzero((void *)CursorP,(sizeof(struct TextRecord)));
        CursorP->Flags =StyleFlagsHasColor;
        CursorP->FontID =Text->FontID;
        CursorP->TextColor = Text->TextColor;
        CursorP->TextHeight = Text->FontHeight;
        CursorP->GlyphCount = 1;
		CursorP->GlyphEntries[0].Shape.FillStylesP = NULL;
		CursorP->GlyphEntries[0].Shape.LineStylesP = NULL;
        getCursor(node_p,CursorP,CurX,CurY);
        CursorP->NextP = NULL;
        endTextRecordP->NextP = CursorP;
        endTextRecordP = CursorP;
    }

    endTextRecordP->NextP = NULL;


    Globle_VarP->GlobleText.TextMatrix = TextMatrix;

    tmpHeadTextRecordP = Globle_VarP->GlobleText.TextRecordsP;
    if(tmpHeadTextRecordP){
	    while(tmpHeadTextRecordP->NextP)
	    	tmpHeadTextRecordP = tmpHeadTextRecordP->NextP;
	    	
	    tmpHeadTextRecordP->NextP = headTextRecordP;
    }else{
    	Globle_VarP->GlobleText.TextRecordsP = headTextRecordP;
    }
//	Globle_VarP->GlobleText.TextRecordsP->NextP = headTextRecordP;
    free(TextAlign);

    return 0;
}

int FontToShape(GNode* node_p,struct Globle_Var *Globle_VarP) {

    FT_Library    library;
    FT_Face       face;
    FT_UInt   glyph_index;
    FT_Glyph glyph;

    UI16                MaxLength =0;
    char*         filename;
    char*         src_str;
    unsigned	char out[OUTLEN];
    int rc;
    int i=0,j=0,outlen =OUTLEN ;
    uint32_t code[OUTLEN];
    struct  DefineEditText *Text;
    dtx_ins_t    *data_p   = (dtx_ins_t*)(node_p->data);

#ifdef PRINT_DG
    fprintf(stderr,"FontToShape start   --- \n");
#endif

    src_str          = NULL;                           /* string    */
    Text = NULL;

    src_str = data_p->value_p;
    Text = data_p->define_p;
    //	filename      = "/usr/home/chenz/myfont/simsun.ttc";
    filename      = "simsun.ttc";

    if (!src_str)
        return 0;

    if(Text->Flags&EditTextHasMaxLength)
        MaxLength = Text->MaxLength;

    rc = code_convert("utf-8","utf-32",src_str,strlen(src_str),out,outlen);
    if(rc == 0) {
        for(i=0,j=0;;i=i+4,j++) {
            if(out[i]=='\0'&&out[i+1]=='\0'&&out[i+2]=='\0'&&out[i+3]=='\0')
                break;
            if(i+4>OUTLEN)
                break;
            code[j] = out[i]<<24|out[i+1]<<16 |out[i+2]<<8|out[i+3];
            Globle_VarP->tmpCode[j]=code[j];
        }
    } else {
        return 0;
    }

    //	freeMyRecA(Globle_VarP);
//    free(Globle_VarP->Gadvance);

    Globle_VarP->MyNum = j;
	if(Globle_VarP->MyNum==0)
		return 0;

	if(Text->Flags&EditTextHasMaxLength){
		Globle_VarP->MyNum = j<=MaxLength ?j:(MaxLength+1);
	}
    Globle_VarP->Mytmp = 0;
    initMyRecA(Globle_VarP);
    Globle_VarP->Gadvance = (int*)malloc(sizeof(int)*Globle_VarP->MyNum);
    bzero((void *)(Globle_VarP->Gadvance),sizeof(FT_Pos)*Globle_VarP->MyNum);

    initRec(Globle_VarP);
    rc = FT_Init_FreeType( &library );
	if(rc){
		return 0;
	}
    rc = FT_New_Face( library,filename,
                 0,
                 &face );
	if(rc){
		return 0;
	}
    FT_Set_Pixel_Sizes(face,1024,0);

    Globle_VarP->scale = (double)1024.0/face->units_per_EM;

    for(i=1;i<j;i++) {
        if(Text->Flags&EditTextHasMaxLength) {
            if(i > MaxLength)
                break;
        }
        initRec(Globle_VarP);
        /* retrieve glyph index from character code */
        glyph_index = FT_Get_Char_Index( face, code[i]);
        /* load glyph image into the slot (erase previous one) */
        FT_Load_Glyph( face, glyph_index, FT_LOAD_NO_SCALE );
        FT_Get_Glyph(face->glyph, &glyph);
        draw_outline((FT_OutlineGlyph) glyph,Globle_VarP);

        Globle_VarP->Mytmp++;
    }

    FT_Done_Glyph(glyph);
    FT_Done_Face    ( face );
    FT_Done_FreeType( library );
#ifdef PRINT_DG

    fprintf(stderr,"FontToShape end   --- \n");
#endif

    return 0;
}

void
draw_outline (FT_OutlineGlyph glyph,struct Globle_Var *Globle_VarP) {
    FT_Outline_Funcs handlers;
    FT_Error err;
    FT_BBox bbox;

    err = FT_Outline_Get_BBox(&glyph->outline, &bbox);

    /* I have a feeling that the bounding box in an EPS is meant to only
     * use integer values, so I round them down and up as appropriate.  */
    handlers.move_to = handle_move_to;
    handlers.line_to = handle_line_to;
    handlers.conic_to = handle_conic_to;
    handlers.cubic_to = handle_cubic_to;
    handlers.shift = 0;
    handlers.delta = 0;

    Globle_VarP->Gadvance[Globle_VarP->Mytmp] = (int) ceil(floatify(bbox.xMax,Globle_VarP)) -(int) floor(floatify(bbox.xMin,Globle_VarP)) ;

    FT_Outline_Decompose(&glyph->outline, &handlers, (void *)Globle_VarP);

    if(Globle_VarP->endRec!=NULL)
        Globle_VarP->endRec->NextP = NULL;

    Globle_VarP->MyRecA[Globle_VarP->Mytmp] = Globle_VarP->headRec;

}

double
floatify (FT_Pos x,struct Globle_Var *Globle_VarP) {
    double rc;

    rc = x*Globle_VarP->scale;
    return (double) rc;
}

int
handle_move_to (FT_Vector *to, void *user) {
    struct StyleChangeRecord *chg ;
    struct Globle_Var *Globle_VarP = (struct Globle_Var *)user;

    chg = (struct StyleChangeRecord*)malloc(sizeof(struct StyleChangeRecord));
    bzero((void *)chg,sizeof(struct StyleChangeRecord));
    Globle_VarP->Gx = floatify(to->x,Globle_VarP) ;
    Globle_VarP->Gy = floatify(to->y,Globle_VarP) *Globle_VarP->yAxis;
    chg->MoveDeltaX = floatify(to->x,Globle_VarP) ;
    chg->MoveDeltaY = floatify(to->y,Globle_VarP) *Globle_VarP->yAxis;
    chg->Flags = StateMoveTo|StateFillStyle1|StateLineStyle;
    chg->FillStyle1 = 1;
    chg->LineStyle = 0;

    (struct StyleChangeRecord*)Globle_VarP->MyRecA[Globle_VarP->Mytmp] = (struct StyleChangeRecord*)malloc(sizeof(struct StyleChangeRecord));
    bzero((void *)(Globle_VarP->MyRecA[Globle_VarP->Mytmp]),sizeof(struct StyleChangeRecord));
    memcpy(Globle_VarP->MyRecA[Globle_VarP->Mytmp],chg,sizeof(struct StyleChangeRecord));
    if (Globle_VarP->headRec==NULL)
        Globle_VarP->headRec = Globle_VarP->MyRecA[Globle_VarP->Mytmp];
    else
        Globle_VarP->endRec->NextP = Globle_VarP->MyRecA[Globle_VarP->Mytmp];
    Globle_VarP->endRec = Globle_VarP->MyRecA[Globle_VarP->Mytmp];

    return 0;
}

int
handle_line_to (FT_Vector *to, void *user) {
    struct StraightEdgeRecord *chg ;
    struct Globle_Var *Globle_VarP = (struct Globle_Var *)user;
    double x = floatify(to->x,Globle_VarP), y = floatify(to->y,Globle_VarP);

    chg = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
	bzero((void *)chg,sizeof(struct StraightEdgeRecord));
    chg->StraightLineFlag = 1;
    chg->StraightLineDeltaX = x - Globle_VarP->Gx;
    chg->StraightLineDeltaY = y*Globle_VarP->yAxis - Globle_VarP->Gy;
    chg->Flags = TStraightEdge;
    chg->VertLineFlag = 0;
    chg->HorLineDeltaX = 0;
    chg->VertLineDeltaY =0;

    (struct StraightEdgeRecord*)Globle_VarP->MyRecA[Globle_VarP->Mytmp] = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(Globle_VarP->MyRecA[Globle_VarP->Mytmp]),sizeof(struct StraightEdgeRecord));
    memcpy(Globle_VarP->MyRecA[Globle_VarP->Mytmp],chg,sizeof(struct StraightEdgeRecord));
    if (Globle_VarP->headRec==NULL)
        Globle_VarP->headRec = Globle_VarP->MyRecA[Globle_VarP->Mytmp];
    else
        Globle_VarP->endRec->NextP = Globle_VarP->MyRecA[Globle_VarP->Mytmp];
    Globle_VarP->endRec = Globle_VarP->MyRecA[Globle_VarP->Mytmp];

    Globle_VarP->Gx = floatify(to->x,Globle_VarP) ;
    Globle_VarP->Gy = floatify(to->y,Globle_VarP) *Globle_VarP->yAxis;

    return 0;
}

int
handle_conic_to (FT_Vector *control, FT_Vector *to, void *user) {
    /* These conic curves have only one control point, which we use
     * (together with the start and end points) to generate the two
     * control points needed for the PostScript curveto operator.
     * I don't know how this stuff works, but stole the formulae
     * from SFontTTF.cpp in Yudit.  The results look right.  */
    struct Globle_Var *Globle_VarP = (struct Globle_Var *)user;
    double x = floatify(to->x,Globle_VarP), y = floatify(to->y,Globle_VarP);
    double cx = floatify(control->x,Globle_VarP), cy = floatify(control->y,Globle_VarP);
    struct CurvedEdgeRecord *chg ;

    chg = (struct CurvedEdgeRecord*)malloc(sizeof(struct CurvedEdgeRecord));
	bzero((void *)chg,sizeof(struct CurvedEdgeRecord));
    chg->ControlDeltaX = cx -Globle_VarP->Gx;
    chg->ControlDeltaY = cy*Globle_VarP->yAxis -Globle_VarP->Gy;
    chg->AnchorDeltaX = x -Globle_VarP->Gx;
    chg->AnchorDeltaY = y*Globle_VarP->yAxis -Globle_VarP->Gy;
    chg->AnchorDeltaX = chg->AnchorDeltaX -chg->ControlDeltaX;
    chg->AnchorDeltaY = chg->AnchorDeltaY -chg->ControlDeltaY;
    chg->Flags = TCurvedEdge;

    (struct CurvedEdgeRecord*)Globle_VarP->MyRecA[Globle_VarP->Mytmp] = (struct CurvedEdgeRecord*)malloc(sizeof(struct CurvedEdgeRecord));
    bzero((void *)(Globle_VarP->MyRecA[Globle_VarP->Mytmp]),sizeof(struct CurvedEdgeRecord));
    memcpy(Globle_VarP->MyRecA[Globle_VarP->Mytmp],chg,sizeof(struct CurvedEdgeRecord));
    if (Globle_VarP->headRec==NULL)
        Globle_VarP->headRec = Globle_VarP->MyRecA[Globle_VarP->Mytmp];
    else
        Globle_VarP->endRec->NextP = Globle_VarP->MyRecA[Globle_VarP->Mytmp];
    Globle_VarP->endRec = Globle_VarP->MyRecA[Globle_VarP->Mytmp];

    Globle_VarP->Gx = floatify(to->x,Globle_VarP) ;
    Globle_VarP->Gy = floatify(to->y,Globle_VarP) *Globle_VarP->yAxis;
    return 0;
}

int
handle_cubic_to (FT_Vector *control1, FT_Vector *control2, FT_Vector *to,
                 void *user) {
    /* This should work, but I haven't seen it used. */
    struct Globle_Var *Globle_VarP = (struct Globle_Var *)user;
    double cx,cy;
    double x = floatify(to->x,Globle_VarP), y = floatify(to->y,Globle_VarP);
    double c2x = floatify(control2->x,Globle_VarP), c2y = floatify(control2->y,Globle_VarP);
    struct CurvedEdgeRecord *chg ;

    chg = (struct CurvedEdgeRecord*)malloc(sizeof(struct CurvedEdgeRecord));
	bzero((void *)chg,sizeof(struct CurvedEdgeRecord));
    cx = (3*c2x-x)/2;
    cy = (3*c2y-y)/2;

    chg->ControlDeltaX = cx -Globle_VarP->Gx;
    chg->ControlDeltaY = cy*Globle_VarP->yAxis -Globle_VarP->Gy;
    chg->AnchorDeltaX = x -Globle_VarP->Gx;
    chg->AnchorDeltaY = y*Globle_VarP->yAxis -Globle_VarP->Gy;
    chg->AnchorDeltaX = chg->AnchorDeltaX -chg->ControlDeltaX;
    chg->AnchorDeltaY = chg->AnchorDeltaY -chg->ControlDeltaY;
    chg->Flags = TCurvedEdge;

    (struct CurvedEdgeRecord*)Globle_VarP->MyRecA[Globle_VarP->Mytmp] = (struct CurvedEdgeRecord*)malloc(sizeof(struct CurvedEdgeRecord));
    bzero((void *)(Globle_VarP->MyRecA[Globle_VarP->Mytmp]),sizeof(struct CurvedEdgeRecord));
    memcpy(Globle_VarP->MyRecA[Globle_VarP->Mytmp],chg,sizeof(struct CurvedEdgeRecord));
    if (Globle_VarP->headRec==NULL)
        Globle_VarP->headRec = Globle_VarP->MyRecA[Globle_VarP->Mytmp];
    else
        Globle_VarP->endRec->NextP = Globle_VarP->MyRecA[Globle_VarP->Mytmp];
    Globle_VarP->endRec = Globle_VarP->MyRecA[Globle_VarP->Mytmp];

    Globle_VarP->Gx = floatify(to->x,Globle_VarP) ;
    Globle_VarP->Gy = floatify(to->y,Globle_VarP)*Globle_VarP->yAxis ;

    return 0;
}

void initRec(struct Globle_Var *Globle_VarP) {
    Globle_VarP->headRec = NULL;
    Globle_VarP->endRec = NULL;
}

void initMyRecA(struct Globle_Var *Globle_VarP) {
    Globle_VarP->MyRecA = (struct ShapeRecord**)malloc(sizeof(struct ShapeRecord*)*Globle_VarP->MyNum);
    bzero((void *)(Globle_VarP->MyRecA),sizeof(struct ShapeRecord*)*Globle_VarP->MyNum);
}

void freeMyRecA(struct Globle_Var *Globle_VarP) {
    struct ShapeRecord *tempShape;
    int i;
    for(i=0;i<Globle_VarP->MyNum-1;i++) {
        tempShape = Globle_VarP->MyRecA[i];
        while(Globle_VarP->MyRecA[i]) {
            tempShape =Globle_VarP->MyRecA[i]->NextP;
            free(Globle_VarP->MyRecA[i]);
            Globle_VarP->MyRecA[i] = tempShape;
        }
    }
}
int code_convert(char *from_charset,char *to_charset,char *inbuf,int inlen,char *outbuf,int outlen) {
    iconv_t cd;
    char **pin = &inbuf;
    char **pout = &outbuf;

    cd = iconv_open(to_charset,from_charset);
    if (cd==0)
        return -1;
    memset(outbuf,0,outlen);

    if (iconv(cd,(const char* *)pin,&inlen,pout,&outlen)==-1)
        return -1;

    iconv_close(cd);
    return 0;
}

int DevicetoShape(GNode* node_p,struct Globle_Var *Globle_VarP) {
    dtx_ins_t    *data_p   = (dtx_ins_t*)(node_p->data);
    struct  DefineFont *Font;
    struct TextRecord *headTextRecordP,*endTextRecordP;
    struct TextRecord *TextRecordP;
    struct TextRecord *tmpHeadTextRecordP;
//    struct TextRecord *TextBoundP;
    struct TextRecord *CursorP;
    //    struct ShapeArray *p;
    struct GlyphEntry *g_p ;
    struct Matrix TextMatrix;
    struct Matrix FontMatrix;
    long x,y;

    int CurPos =0;
    long CurX,CurY;
    int showCur = 1;

    int row = 0,rownum = 0;
    long Textlen = 0;
    long *TextAlign;

    long FontHeight=0;
    int i;

    struct  DefineEditText *Text;

    x=y=0;

	showCur = data_p->focusd;
    Text = data_p->define_p;
    Font = (struct  DefineFont *)data_p->swf_p->dict_p->dict[Text->FontID];

    headTextRecordP = NULL;
    endTextRecordP = NULL;

    if(Globle_VarP->MyNum ==0){
//        Globle_VarP->GlobleText.TextRecordsP = NULL;
        return 0;
    }

    bzero((void *)(&TextMatrix),sizeof(struct Matrix));
    MatrixPrepare(&TextMatrix);
    bzero((void *)(&FontMatrix),sizeof(struct Matrix));

    FontHeight=Text->FontHeight;
    FontMatrix.HasScale=1;
    FontMatrix.ScaleX=FontHeight/1024.0;
    FontMatrix.ScaleY=FontHeight/1024.0;

    TextRecordP = (struct TextRecord*)malloc(sizeof(struct TextRecord)+sizeof(struct GlyphEntry)*(Globle_VarP->MyNum-1));
    bzero((void *)(TextRecordP),sizeof(struct TextRecord)+sizeof(struct GlyphEntry)*(Globle_VarP->MyNum-1));
    TextRecordP->Flags =StyleFlagsHasColor;
    TextRecordP->FontID =Text->FontID;
    TextRecordP->TextColor = Text->TextColor;
    TextRecordP->TextHeight = Text->FontHeight;
    TextRecordP->GlyphCount = Globle_VarP->MyNum-1;

    //get text rows
    for(i=1;i<Globle_VarP->MyNum-1;i++) {
        if(Text->Flags&EditTextMultiline) {
            if(Globle_VarP->tmpCode[i]=='\r') {
                x=0;
                rownum++;
            }
        }
        if(Text->Flags&EditTextWordWrap)
            if((x+Globle_VarP->Gadvance[i]*(FontMatrix.ScaleX))>Text->Bounds.Xmax) {
                x=0;
                rownum++;
            }
        x+=Globle_VarP->Gadvance[i]*(FontMatrix.ScaleX);
    }
    TextAlign = (long *)malloc(sizeof(long)*(rownum+1));
    bzero((void*)TextAlign,sizeof(long)*(rownum+1));
    TextAlign[0] = 0;
    row = 0;
    if(Text->Flags&EditTextHasLayout) {
        for(i=1;i<Globle_VarP->MyNum-1;i++) {
            switch(Text->Align) {
            case 0:
                TextAlign[row] = 0;
                break;
            case 1:
                TextAlign[row] = Text->Bounds.Xmax - Textlen - 500*(FontMatrix.ScaleX);
                break;
            case 2:
                TextAlign[row] = (Text->Bounds.Xmax - Textlen)/2;
                break;
            case 3:
                TextAlign[row] = 0;
                break;
            }
            if(Text->Flags&EditTextMultiline) {
                if(Globle_VarP->tmpCode[i]=='\r') {
                    Textlen = 0;
                    row++;
                }
            }
            if(Text->Flags&EditTextWordWrap)
                if((Textlen+Globle_VarP->Gadvance[i]*(FontMatrix.ScaleX))>Text->Bounds.Xmax) {
                    Textlen = 0;
                    row++;
                }
            Textlen+=Globle_VarP->Gadvance[i]*(FontMatrix.ScaleX);
        }
    }
    switch(Text->Align) {
    case 0:
        TextAlign[row] = 0;
        break;
    case 1:
        TextAlign[row] = Text->Bounds.Xmax - Textlen - 500*(FontMatrix.ScaleX);
        break;
    case 2:
        TextAlign[row] = (Text->Bounds.Xmax - Textlen)/2;
        break;
    case 3:
        TextAlign[row] = 0;
        break;
    }

    row = 0;
    y=Text->FontHeight;
    x=TextAlign[row];

    CurPos = i+1;
    CurY=Text->FontHeight;
    CurX=TextAlign[row];

    for(i=0;i<Globle_VarP->MyNum-1;i++) {
        if(Text->Flags&EditTextMultiline) {
            if(Globle_VarP->tmpCode[i]=='\r') {
                row++;
                x=TextAlign[row];
                y+=Text->FontHeight;
                if(i<CurPos) {
                    CurY+=Text->FontHeight;
                    CurX=TextAlign[row];
                }
            }
        }
        if(Text->Flags&EditTextWordWrap)
            if((x+Globle_VarP->Gadvance[i]*(FontMatrix.ScaleX))>Text->Bounds.Xmax) {
                row++;
                x=TextAlign[row];
                y+=Text->FontHeight;
                if(i<CurPos) {
                    CurY+=Text->FontHeight;
                    CurX=TextAlign[row];
                }
            }
        g_p = &(TextRecordP->GlyphEntries[i]);

        mat_new(&(g_p->GlyphMatrix));
        g_p->GlyphMatrix.TranslateX	= x;
        g_p->GlyphMatrix.TranslateY	= y;
        g_p->GlyphMatrix.ScaleX	= FontHeight/1024.0;
        g_p->GlyphMatrix.ScaleY	= FontHeight/1024.0;

        g_p->Shape.CharacterType	= CharShape;
        g_p->Shape.ShapeBounds	= Text->Bounds;
        g_p->Shape.ShapeRecordsP	= Globle_VarP->MyRecA[i];
        x+=Globle_VarP->Gadvance[i]*(FontMatrix.ScaleX);
        if(i<CurPos) {
            CurX+=Globle_VarP->Gadvance[i]*(FontMatrix.ScaleX);
        }

    }

    headTextRecordP = TextRecordP;
    TextRecordP->NextP = NULL;
    endTextRecordP = TextRecordP;
/*
    if(Text->Flags&EditTextBorder) {
        TextBoundP = (struct TextRecord*)malloc(sizeof(struct TextRecord));
        bzero((void *)TextBoundP,(sizeof(struct TextRecord)));
        TextBoundP->Flags =StyleFlagsHasColor;
        TextBoundP->FontID =Text->FontID;
        TextBoundP->TextColor = Text->TextColor;
        TextBoundP->TextHeight = Text->FontHeight;
        TextBoundP->GlyphCount = 1;
		TextBoundP->GlyphEntries[0].Shape.FillStylesP = NULL;
		TextBoundP->GlyphEntries[0].Shape.LineStylesP = NULL;
        getTextBounds(node_p,TextBoundP);
        TextBoundP->NextP = NULL;
        endTextRecordP->NextP = TextBoundP;
        endTextRecordP = TextBoundP;
    }
*/
    if(showCur) {
        CursorP = (struct TextRecord*)malloc(sizeof(struct TextRecord));
        bzero((void *)CursorP,(sizeof(struct TextRecord)));
        CursorP->Flags =StyleFlagsHasColor;
        CursorP->FontID =Text->FontID;
        CursorP->TextColor = Text->TextColor;
        CursorP->TextHeight = Text->FontHeight;
        CursorP->GlyphCount = 1;
#ifdef PRINT_DG
    fprintf(stderr,"FontToShape start   --- CursorP->GlyphEntries[0].Shape.FillStylesP =%p\n",CursorP->GlyphEntries[0].Shape.FillStylesP);
#endif

		CursorP->GlyphEntries[0].Shape.FillStylesP = NULL;
		CursorP->GlyphEntries[0].Shape.LineStylesP = NULL;
        getCursor(node_p,CursorP,CurX,CurY);
        CursorP->NextP = NULL;
        endTextRecordP->NextP = CursorP;
        endTextRecordP = CursorP;
    }

    endTextRecordP->NextP = NULL;

    Globle_VarP->GlobleText.TextMatrix = TextMatrix;
    
    tmpHeadTextRecordP = Globle_VarP->GlobleText.TextRecordsP;
    if(tmpHeadTextRecordP){
	    while(tmpHeadTextRecordP->NextP)
	    	tmpHeadTextRecordP = tmpHeadTextRecordP->NextP;
	    	
	    tmpHeadTextRecordP->NextP = headTextRecordP;
    }else{
    	Globle_VarP->GlobleText.TextRecordsP = headTextRecordP;
    }
//    Globle_VarP->GlobleText.TextRecordsP = headTextRecordP;

    free(TextAlign);
    return 0;
}
void freeDefineText(struct DefineText *data) {
    struct TextRecord* tmp;
    int i;
    tmp =NULL;
    if(data==NULL)
        return ;
    if(data->TextRecordsP ==NULL)
        return;
    while(data->TextRecordsP) {
        tmp = data->TextRecordsP->NextP;
        for(i=0;i<data->TextRecordsP->GlyphCount;i++) {
            freeDefineShape(&(data->TextRecordsP->GlyphEntries[i].Shape));
        }
        free(data->TextRecordsP);
        data->TextRecordsP =tmp;
    }

}
void freeDefineShape(struct DefineShape *data) {
    struct ShapeRecord *tmp;
    int i = 0;
    tmp = NULL;
    assert(data->FillStylesP==0);
    if(data->FillStylesP) {
        for(i=0; i<data->FillStylesP->count; i++) {
            freeFillStyle(&(data->FillStylesP->FillStyles[i]));
        }
        free(data->FillStylesP);
        data->FillStylesP = NULL;
    }

    if(data->LineStylesP) {
        free(data->LineStylesP);
        data->LineStylesP = NULL;
    }
    if(data->ShapeRecordsP == NULL)
        return;
    while(data->ShapeRecordsP) {
        tmp = data->ShapeRecordsP->NextP;
        free(data->ShapeRecordsP);
        data->ShapeRecordsP =tmp;
    }
}
void freeFillStyle(struct FillStyle *data) {
    if(data->GradientP) {
        free(data->GradientP->g_ramp);
        data->GradientP->g_ramp = NULL;
        free(data->GradientP);
        data->GradientP = NULL;
    }
    if(data->cmap) {
        free(data->cmap);
        data->cmap = NULL;
    }
    if(data->alpha_table) {
        free(data->alpha_table);
        data->alpha_table = NULL;
    }
}

int DecomposeHTML(char *str) {
    return 0;
}

int getTextBounds(GNode* node_p,struct TextRecord *outRecordP) {
    struct  DefineEditText *Text;
    //    struct DefineShape	 Shape;
    struct StyleChangeRecord *StyleChangeRecordP;
    struct StraightEdgeRecord *StraightEdgeRecordP;

    struct ShapeRecord *headShapeP,*endShapeP;
    struct ShapeRecord *ShapeP;

    double tmpscale;

    dtx_ins_t    *data_p   = (dtx_ins_t*)(node_p->data);

    Text = data_p->define_p;

    headShapeP = NULL;
    endShapeP = NULL;

    tmpscale = 1024.0/Text->FontHeight;
    StyleChangeRecordP = (struct StyleChangeRecord*)malloc(sizeof(struct StyleChangeRecord));
    bzero((void *)(StyleChangeRecordP),sizeof(struct StyleChangeRecord));
    StyleChangeRecordP->MoveDeltaX = Text->Bounds.Xmin*tmpscale;
    StyleChangeRecordP->MoveDeltaY = Text->Bounds.Ymin*tmpscale;
    /*
    printf("\n---------------Text->Bounds---------------Xmin:%d	,Ymin:%d	,Xmax:%d	,Ymax:%d	.\n"\
    	,Text->Bounds.Xmin,Text->Bounds.Ymin,Text->Bounds.Xmax,Text->Bounds.Ymax);
    printf("\n---------------data_p->boundary---------------Xmin:%d	,Ymin:%d	,Xmax:%d	,Ymax:%d	.\n"\
    	,data_p->boundary.Xmin,data_p->boundary.Ymin,data_p->boundary.Xmax,data_p->boundary.Ymax);
    */
    StyleChangeRecordP->Flags = StateMoveTo|StateFillStyle0|StateFillStyle1|StateLineStyle;
    StyleChangeRecordP->FillStyle0 = 0;
    StyleChangeRecordP->FillStyle1 = 1;
    StyleChangeRecordP->LineStyle = 0;

    ShapeP = (struct ShapeRecord *)StyleChangeRecordP;
    headShapeP = ShapeP ;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 0;
    StraightEdgeRecordP->HorLineDeltaX = (Text->Bounds.Xmax - Text->Bounds.Xmin)*tmpscale;
    StraightEdgeRecordP->VertLineDeltaY =0;

    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    headShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 1;
    StraightEdgeRecordP->HorLineDeltaX = 0;
    StraightEdgeRecordP->VertLineDeltaY =(Text->Bounds.Ymax - Text->Bounds.Ymin)*tmpscale;

    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 0;
    StraightEdgeRecordP->HorLineDeltaX = (Text->Bounds.Xmin - Text->Bounds.Xmax)*tmpscale;
    StraightEdgeRecordP->VertLineDeltaY =0;

    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 1;
    StraightEdgeRecordP->HorLineDeltaX = 0;
    StraightEdgeRecordP->VertLineDeltaY =(Text->Bounds.Ymin - Text->Bounds.Ymax)*tmpscale;

    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StyleChangeRecordP = (struct StyleChangeRecord*)malloc(sizeof(struct StyleChangeRecord));
    bzero((void *)(StyleChangeRecordP),sizeof(struct StyleChangeRecord));
    StyleChangeRecordP->MoveDeltaX = (Text->Bounds.Xmin + 20)*tmpscale;
    StyleChangeRecordP->MoveDeltaY = (Text->Bounds.Ymin + 20)*tmpscale;
    StyleChangeRecordP->Flags = StateMoveTo|StateFillStyle0|StateFillStyle1|StateLineStyle;
    StyleChangeRecordP->FillStyle0 = 1;
    StyleChangeRecordP->FillStyle1 = 0;
    StyleChangeRecordP->LineStyle = 0;
    ShapeP = (struct ShapeRecord *)StyleChangeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 0;
    StraightEdgeRecordP->HorLineDeltaX = (Text->Bounds.Xmax - Text->Bounds.Xmin - 40)*tmpscale;
    StraightEdgeRecordP->VertLineDeltaY =0;
    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 1;
    StraightEdgeRecordP->HorLineDeltaX = 0;
    StraightEdgeRecordP->VertLineDeltaY =(Text->Bounds.Ymax - Text->Bounds.Ymin - 40)*tmpscale;
    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 0;
    StraightEdgeRecordP->HorLineDeltaX = (Text->Bounds.Xmin - Text->Bounds.Xmax +40)*tmpscale;
    StraightEdgeRecordP->VertLineDeltaY =0;
    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 1;
    StraightEdgeRecordP->HorLineDeltaX = 0;
    StraightEdgeRecordP->VertLineDeltaY =(Text->Bounds.Ymin - Text->Bounds.Ymax +40)*tmpscale;
    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    endShapeP->NextP = NULL;

    mat_new(&(outRecordP->GlyphEntries[0].GlyphMatrix));
    outRecordP->GlyphEntries[0].GlyphMatrix.TranslateX	= 0;
    outRecordP->GlyphEntries[0].GlyphMatrix.TranslateY	= 0;
    outRecordP->GlyphEntries[0].GlyphMatrix.ScaleX	= Text->FontHeight/1024.0;
    outRecordP->GlyphEntries[0].GlyphMatrix.ScaleY	= Text->FontHeight/1024.0;

    outRecordP->GlyphEntries[0].Shape.CharacterType	= CharShape;
    //outRecordP->GlyphEntries[0].Shape.ShapeBounds	= Text->Bounds;
    outRecordP->GlyphEntries[0].Shape.ShapeRecordsP	= headShapeP;

    return 0;
}

int getCursor(GNode* node_p,struct TextRecord *outRecordP,long x,long y) {
    struct  DefineEditText *Text;
    //    struct DefineShape	 Shape;
    struct StyleChangeRecord *StyleChangeRecordP;
    struct StraightEdgeRecord *StraightEdgeRecordP;

    struct ShapeRecord *headShapeP,*endShapeP;
    struct ShapeRecord *ShapeP;

    double tmpscale;

    dtx_ins_t    *data_p   = (dtx_ins_t*)(node_p->data);

    Text = data_p->define_p;

    headShapeP = NULL;
    endShapeP = NULL;

    tmpscale = 1024.0/Text->FontHeight;

    StyleChangeRecordP = (struct StyleChangeRecord*)malloc(sizeof(struct StyleChangeRecord));
    bzero((void *)(StyleChangeRecordP),sizeof(struct StyleChangeRecord));
    StyleChangeRecordP->MoveDeltaX = x*tmpscale;
    StyleChangeRecordP->MoveDeltaY = (y - Text->FontHeight*0.85)*tmpscale;
    /*
    printf("\n---------------Text->Bounds---------------Xmin:%d	,Ymin:%d	,Xmax:%d	,Ymax:%d	.\n"\
    	,Text->Bounds.Xmin,Text->Bounds.Ymin,Text->Bounds.Xmax,Text->Bounds.Ymax);
    printf("\n---------------data_p->boundary---------------Xmin:%d	,Ymin:%d	,Xmax:%d	,Ymax:%d	.\n"\
    	,data_p->boundary.Xmin,data_p->boundary.Ymin,data_p->boundary.Xmax,data_p->boundary.Ymax);
    */
    StyleChangeRecordP->Flags = StateMoveTo|StateFillStyle1|StateLineStyle;
    //    StyleChangeRecordP->FillStyle0 = 0;
    StyleChangeRecordP->FillStyle1 = 1;
    StyleChangeRecordP->LineStyle = 0;

    ShapeP = (struct ShapeRecord *)StyleChangeRecordP;
    headShapeP = ShapeP ;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 0;
    StraightEdgeRecordP->HorLineDeltaX = 40*tmpscale;
    StraightEdgeRecordP->VertLineDeltaY =0;

    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    headShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 1;
    StraightEdgeRecordP->HorLineDeltaX = 0;
    StraightEdgeRecordP->VertLineDeltaY =Text->FontHeight*tmpscale;

    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 0;
    StraightEdgeRecordP->HorLineDeltaX = (-40)*tmpscale;
    StraightEdgeRecordP->VertLineDeltaY =0;

    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    StraightEdgeRecordP = (struct StraightEdgeRecord*)malloc(sizeof(struct StraightEdgeRecord));
    bzero((void *)(StraightEdgeRecordP),sizeof(struct StraightEdgeRecord*));
    StraightEdgeRecordP->StraightLineFlag = 0;
    StraightEdgeRecordP->Flags = TStraightEdge;
    StraightEdgeRecordP->VertLineFlag = 1;
    StraightEdgeRecordP->HorLineDeltaX = 0;
    StraightEdgeRecordP->VertLineDeltaY = Text->FontHeight*(-1)*tmpscale;

    ShapeP = (struct ShapeRecord *)StraightEdgeRecordP;
    endShapeP->NextP = ShapeP;
    endShapeP = ShapeP;

    endShapeP->NextP = NULL;

    mat_new(&(outRecordP->GlyphEntries[0].GlyphMatrix));
    outRecordP->GlyphEntries[0].GlyphMatrix.TranslateX	= 1*tmpscale;
    outRecordP->GlyphEntries[0].GlyphMatrix.TranslateY	= 0;//Text->FontHeight*(-1)*tmpscale;
    outRecordP->GlyphEntries[0].GlyphMatrix.ScaleX	= Text->FontHeight/1024.0;
    outRecordP->GlyphEntries[0].GlyphMatrix.ScaleY	= Text->FontHeight/1024.0;

    outRecordP->GlyphEntries[0].Shape.CharacterType	= CharShape;
    //outRecordP->GlyphEntries[0].Shape.ShapeBounds	= Text->Bounds;
    outRecordP->GlyphEntries[0].Shape.ShapeRecordsP	= headShapeP;

    return 0;
}
int drawTextBounds(GNode* node_p,struct Globle_Var *Globle_VarP){
    dtx_ins_t    *data_p   = (dtx_ins_t*)(node_p->data);
    struct  DefineFont *Font;
    struct TextRecord *TextBoundP;

    struct Matrix TextMatrix;
    struct  DefineEditText *Text;

    Text = data_p->define_p;
    Font = (struct  DefineFont *)data_p->swf_p->dict_p->dict[Text->FontID];

    if(Text->Flags&EditTextBorder) {
        TextBoundP = (struct TextRecord*)malloc(sizeof(struct TextRecord));
        bzero((void *)TextBoundP,(sizeof(struct TextRecord)));
        TextBoundP->Flags =StyleFlagsHasColor;
        TextBoundP->FontID =Text->FontID;
        TextBoundP->TextColor = Text->TextColor;
        TextBoundP->TextHeight = Text->FontHeight;
        TextBoundP->GlyphCount = 1;
		TextBoundP->GlyphEntries[0].Shape.FillStylesP = NULL;
		TextBoundP->GlyphEntries[0].Shape.LineStylesP = NULL;
        getTextBounds(node_p,TextBoundP);
        TextBoundP->NextP = NULL;

	    bzero((void *)(&TextMatrix),sizeof(struct Matrix));
	    MatrixPrepare(&TextMatrix);
	    Globle_VarP->GlobleText.TextMatrix = TextMatrix;
	    Globle_VarP->GlobleText.TextRecordsP = TextBoundP;
    }else{
	    Globle_VarP->GlobleText.TextRecordsP = NULL;
    }


	return 0;	
}
