#include "base_types.h"
#include "config.h"
#include "instance.h"
#include "movie_clips_ins.h"
#include "movie_clips_def.h"
#include "button_ins.h"
#include "button_def.h"
#include "dynamic_text_ins.h"
#include "dynamic_text_def.h"
#include "morphing_ins.h"
#include "shape_ins.h"
#include "static_text_ins.h"
#include "swf_file_pub.h"
#include "changed.h"
#include "action.h"
#include <glib.h>
#include <assert.h>
#include <stdlib.h>
#include "dynamic_var.h"
#if WITH_DMALLOC
#include <dmalloc.h>
#endif

extern player_t	*player_p;
void ins_change(GNode* node_p,struct PlaceObject* cmd_p) {
    instance_t 			*data_p = (instance_t*)(node_p->data);
    struct DefineCharacter 	*define_p = (struct DefineCharacter*)(data_p->swf_p->dict_p->dict[cmd_p->CharacterID]);
    swf_file_t			*swf_p = data_p->swf_p;
    changed_t			*chg_p = swf_p->changed_p;

    // ıǰǼ box_bounding
    chg_add_boundary(chg_p,node_p);
    if (cmd_p->Flags & PlaceFlagHasColorTransform) {
        data_p->cxform = cmd_p->ColorTransform;
	data_p->pic_dirty = TRUE;
    };
    if (cmd_p->Flags & PlaceFlagHasMatrix) {
	// ƶκα仯,ɽڵͼ.
        if ((data_p->matrix.ScaleX != cmd_p->Matrix.ScaleX)
                || (data_p->matrix.ScaleY != cmd_p->Matrix.ScaleY)
                || (data_p->matrix.RotateSkew0 != cmd_p->Matrix.RotateSkew0)
                || (data_p->matrix.RotateSkew1 != cmd_p->Matrix.RotateSkew1)) {
	    data_p->pic_dirty = TRUE;
        }
        data_p->matrix = cmd_p->Matrix;
    };
    if (cmd_p->Flags & PlaceFlagHasClipDepth) {
        data_p->clip_depth = cmd_p->ClipDepth;
    };
    if (cmd_p->Flags & PlaceFlagHasCharacter) {
        data_p->define_p = define_p;
    };
    switch (data_p->ins_type) {
    case INS_MC :
        mc_ins_change(node_p,cmd_p);
        break;
    case INS_BTN:
        btn_ins_change(node_p,cmd_p);
        break;
    case INS_STX:
        stx_ins_change(node_p,cmd_p);
        break;
    case INS_DTX:
        dtx_ins_change(node_p,cmd_p);
        break;
    case INS_MRH:
        mrp_ins_change(node_p,cmd_p);
        break;
    case INS_SHP:
        shp_ins_change(node_p,cmd_p);
        break;
    };
    data_p->dirty	= TRUE;
    if (data_p->pic_dirty) {
	printf("node %s pic dirty\n",data_p->name_p);
//	data_p->pic_dirty = FALSE;
    };
};

GNode* ins_new(swf_file_t *swf_p,struct PlaceObject * cmd_p) {
    instance_t 		   *data_p 	= NULL;
    GNode		   *node_p	= NULL;
    struct DefineCharacter *define_p 	= (struct DefineCharacter*)(swf_p->dict_p->dict[cmd_p->CharacterID]);

    if (define_p == 0) {
        assert(0);
    };
    switch (define_p->CharacterType) {
    case CharMovieClip:
        data_p = (instance_t*)g_new0(mc_ins_t,1);
        data_p->ins_type = INS_MC;
        ((mc_ins_t*)data_p)->last_frame = 0;
        ((mc_ins_t*)data_p)->next_frame = 0;
        ((mc_ins_t*)data_p)->state = MC_PLAY;
        node_p = g_node_new(data_p);
        break;
    case CharButton:
        data_p = (instance_t*)g_new0(btn_ins_t,1);
        data_p->ins_type = INS_BTN;
        node_p = g_node_new(data_p);
        ((btn_ins_t*)data_p)->last_state = BtnStateIdle;
        ((btn_ins_t*)data_p)->current_state = BtnStateOutUp;
        break;
    case CharEditText:
        data_p = (instance_t*)g_new0(dtx_ins_t,1);
        data_p->ins_type = INS_DTX;
        node_p = g_node_new(data_p);
        break;
    case CharText:
        data_p = (instance_t*)g_new0(stx_ins_t,1);
        data_p->ins_type = INS_STX;
        node_p = g_node_new(data_p);
        break;
    case CharMorphShape:
        data_p = (instance_t*)g_new0(mrp_ins_t,1);
        data_p->ins_type = INS_MRH;
        ((mrp_ins_t*)data_p)->ratio    	    = cmd_p->Ratio;
        ((mrp_ins_t*)data_p)->last_ratio    = cmd_p->Ratio - 1;
        node_p = g_node_new(data_p);
        break;
    case CharShape:
        data_p = (instance_t*)g_new0(shp_ins_t,1);
        data_p->ins_type = INS_SHP;
        node_p = g_node_new(data_p);
        break;
    };
    data_p->swf_p 	= swf_p;
    if (cmd_p->Flags & PlaceFlagHasColorTransform) {
        data_p->cxform = cmd_p->ColorTransform;
    } else {
        cxform_new(&data_p->cxform);
    }
    data_p->matrix 	= cmd_p->Matrix;
    //    assert(data_p->matrix.ScaleX > 0);
    data_p->clip_depth 	= cmd_p->ClipDepth;
    data_p->depth 	= cmd_p->Depth;
    data_p->define_p 	= define_p;
    data_p->dirty	= TRUE;
    data_p->pic_dirty	= TRUE;
    data_p->visible	= TRUE;
    mat_new(&data_p->ab_matrix);
    rect_new(&data_p->boundary);
    if (cmd_p->NameP) {
        data_p->name_p 	= g_strdup(cmd_p->NameP);
    }
    switch (data_p->ins_type) {
    case INS_MC:
        mc_ins_change(node_p,cmd_p);
        if (data_p->name_p == NULL) {
            data_p->name_p=g_strdup_printf("instance%d",swf_p->next_ins_name_num);
            swf_p->next_ins_name_num++;
        };
        break;
    case INS_BTN:
        btn_ins_change(node_p,cmd_p);
        if (data_p->name_p == NULL) {
            data_p->name_p=g_strdup_printf("instance%d",swf_p->next_ins_name_num);
            swf_p->next_ins_name_num++;
        };
        break;
    case INS_DTX: {  // "_root.year_txt" , _root ص
            char	**str_array = NULL;
            int 	i=0;
#define MAX_DEPTH 20

            if (((struct DefineEditText*)(data_p->define_p))->VariableNameP[0]) {
                str_array = g_strsplit(g_strdup(((struct DefineEditText*)(data_p->define_p))->VariableNameP),".",MAX_DEPTH);
                while (str_array[i+1] != NULL)
                    i++;
                ((dtx_ins_t*)data_p)->var_name_p  = g_strdup((char*)(str_array[i]));
                g_strfreev(str_array);
            };
        }
        ((dtx_ins_t*)data_p)->focusd = FALSE;
        if (data_p->name_p == NULL) {
            data_p->name_p=g_strdup_printf("instance%d",swf_p->next_ins_name_num);
            swf_p->next_ins_name_num++;
        };
        if (((dtx_ins_t*)data_p)->var_full_name_p) {
            assert(0);
            ((dtx_ins_t*)data_p)->value_p = g_strdup(g_datalist_get_data(&swf_p->dvar_list_p,((dtx_ins_t*)data_p)->var_full_name_p));
            if (!(((dtx_ins_t*)data_p)->value_p)) {
                ((dtx_ins_t*)data_p)->value_p  = g_strdup(((struct DefineEditText*)(data_p->define_p))->InitialTextP);
            };
        };
        //        dtx_ins_change(node_p,cmd_p);
        break;
    case INS_STX:
        stx_ins_change(node_p,cmd_p);
        break;
    case INS_MRH:
        mrp_ins_change(node_p,cmd_p);
        break;
    case INS_SHP:
        shp_ins_change(node_p,cmd_p);
        break;
    };
    return node_p;
};

// ½ڵ㱻뵽кִ,Ϊڲڵ֮ǰ,ڵ   ֪,
// ֻڲ֮,ſܽȫ֮Ĳ.
void ins_new_after(GNode* node_p) { 
    instance_t 	*data_p = (instance_t*)(node_p->data);
    dtx_ins_t	*dtx_data_p = (dtx_ins_t*)data_p;
    mc_ins_t	*mc_data_p = (mc_ins_t*)data_p;
    char	*p;

    switch (data_p->ins_type) {
    case INS_DTX:
        if (dtx_data_p->var_name_p) {
            // µıȫ
            dtx_data_p->var_full_name_p = dtx_get_var_full_name(node_p);
            p = g_ascii_strdown(dtx_data_p->var_full_name_p,-1);
            free(dtx_data_p->var_full_name_p);
            dtx_data_p->var_full_name_p = p;
            printf("new dtx's var %s\n",dtx_data_p->var_full_name_p);
            // ûͬ,,ʹ InitialTextPΪֵ;
            ((dtx_ins_t*)data_p)->value_p = dvar_get_value(dtx_data_p->var_full_name_p);
            if (!(((dtx_ins_t*)data_p)->value_p)) {
                printf("create var %s\n",((dtx_ins_t*)data_p)->var_full_name_p);
                dvar_set_value(dtx_data_p->var_full_name_p,((struct DefineEditText*)(data_p->define_p))->InitialTextP);
            };
        } else { //  dtx ûб,Լһ. dtx ھ̬,ݲ var .
	    dtx_data_p->var_full_name_p = g_strdup_printf("__%s__var",dtx_data_p->name_p);
            dvar_set_value(dtx_data_p->var_full_name_p,((struct DefineEditText*)(data_p->define_p))->InitialTextP);
	};
        dtx_ins_change(node_p,NULL);
        break;
    case INS_MC:
	//  mc  onload ¼,֮.
        if ((mc_data_p->actions_p) && (mc_data_p->actions_p->ClipEventLoadP)) {
    	    to_exec_t 	*to_exec_p;
            // mc on load event
            to_exec_p = g_new0(to_exec_t,1);
            to_exec_p->as_p = mc_data_p->actions_p->ClipEventLoadP;
            to_exec_p->name_p = ins_node_to_name(node_p);
            player_p->actionq_p = g_slist_append(player_p->actionq_p,to_exec_p);
        };
        break;
    };
};

// ÿڵ  matrix,   matrix(ab_matrix) 䶨е  õĻϵ.
void ins_fresh_boundary(GNode* node_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);

    if (node_p->parent == NULL) { // ڵ㲻
        return;
    };
    data_p->ab_matrix = mat_multi(&(((instance_t*)(node_p->parent->data))->ab_matrix),&data_p->matrix);
    switch(data_p->ins_type) {
    case INS_SHP:
        data_p->boundary  = mat_multi_rect(&data_p->ab_matrix,&(((shp_ins_t*)data_p)->shape_p->ShapeBounds));
        break;
    case INS_DTX:
    case INS_STX:
	assert(((stx_ins_t*)data_p)->text_p);
        data_p->boundary  = mat_multi_rect(&data_p->ab_matrix,&(((stx_ins_t*)data_p)->text_p->TextBounds));
        break;
    case INS_MC:
        break;
    case INS_MRH:
        data_p->boundary  = mat_multi_rect(&data_p->ab_matrix,&(((shp_ins_t*)data_p)->shape_p->ShapeBounds));
        break;
    };
    //    assert(data_p->boundary.Ymin <= data_p->boundary.Ymax);
};

static gboolean ins_destory_data(GNode* node_p,gpointer data_in_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    dtx_ins_t	*dtx_data_p = (dtx_ins_t*)data_p;

    if (data_p->name_p) {
        free(data_p->name_p);
    };
    if (data_p->full_name_p) {
        free(data_p->full_name_p);
    };
    switch(data_p->ins_type) {
    case INS_DTX:
        /*
               if (dtx_data_p->value_p) {
                   free(dtx_data_p->value_p);
               };
        */
        if (dtx_data_p->var_name_p) {
            free(dtx_data_p->var_name_p);
        };
        if (dtx_data_p->var_full_name_p) {
            free(dtx_data_p->var_full_name_p);
        };
    };

    node_p->data=(void*)0xd3d3d3d3;
    free(data_p);

    return FALSE;
};

// ɾ. node   data
void ins_destory(GNode* node_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    swf_file_t	*swf_p  = data_p->swf_p;
    changed_t	*chg_p  = swf_p->changed_p;

    // ɾǰǼ box_bounding
    chg_add_boundary(chg_p,node_p);

    g_node_traverse(node_p,G_IN_ORDER,G_TRAVERSE_ALL,-1,ins_destory_data,NULL);
    g_node_destroy(node_p);
};


static GNode *ins_name_to_node_do(GNode* node_p,char** name_ary_p,int depth) {
    GNode *child = node_p;
    char  *name_p = name_ary_p[depth];

    while (child) {
        if (((instance_t*)(child->data))->name_p != NULL) {
            if (g_strcasecmp(((instance_t*)(child->data))->name_p,name_p)==0) {//  ?
                if (name_ary_p[depth+1] == NULL) {	// һ ?
                    return child;
                } else {
                    return ins_name_to_node_do(g_node_first_child(child),name_ary_p,depth+1);
                };
            };
        };
        child = child->next;
    };
    return 0;
};

#define MAX_DEPTH 20
//  a.b.c.d ʽ,ضӦڵָ.
// : Ƚ a.b.c.d  . ֽɰ 4 ִִ array.
// 4 ִΪ˶ֱ 4 е.õݹÿб,ǰҵ
// ݹһ.
GNode* ins_name_to_node(GNode* node_p,const char* name_p) {
    char	**str_array;
    GNode	*p = NULL;

    str_array = g_strsplit(name_p,".",MAX_DEPTH);

    p = ins_name_to_node_do(node_p,str_array,0);
    g_strfreev(str_array);
    return p;
};

// ȡڵȫ.  ִһ,Ϊȫ.
char* ins_node_to_name(GNode* node_p) {
    GNode* p;
    char  *n1_p = NULL , *n2_p = NULL;

    p = node_p;
    while (p) {
        n2_p = g_strjoin(".",((instance_t*)(p->data))->name_p,n1_p,NULL);
        if (n1_p)
            free(n1_p);
        n1_p = n2_p;
        p = p->parent;
    }
    return n2_p;
};

// ԵĶȡ,.
double ins_get_x(GNode* node_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    return data_p->matrix.TranslateX / TWIPS_PER_POINT;
};

void ins_set_x(GNode* node_p,double value) {
    instance_t 	*data_p = (instance_t*)(node_p->data);

    data_p->matrix.TranslateX = value * TWIPS_PER_POINT;
    data_p->dirty = TRUE;
};

double ins_get_y(GNode* node_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    return data_p->matrix.TranslateY / TWIPS_PER_POINT;
};

void ins_set_y(GNode* node_p,double value) {
    instance_t 	*data_p = (instance_t*)(node_p->data);

    data_p->matrix.TranslateY = value * TWIPS_PER_POINT;
    data_p->dirty = TRUE;
};

float ins_get_xscale(GNode* node_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    return data_p->matrix.ScaleX;
};

void ins_set_xscale(GNode* node_p,float value) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    data_p->matrix.ScaleX = value;
    data_p->dirty = TRUE;
};

float ins_get_yscale(GNode* node_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    return data_p->matrix.ScaleX;
};

void ins_set_yscale(GNode* node_p,float value) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    data_p->matrix.ScaleY = value;
    data_p->dirty = TRUE;
};

gboolean ins_get_visible(GNode* node_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    return data_p->visible;
};

void ins_set_visible(GNode* node_p,gboolean value) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    data_p->visible = value;
    data_p->dirty = TRUE;
};

long ins_get_currentframe(GNode* node_p) {
    mc_ins_t 	*data_p = (mc_ins_t*)(node_p->data);
    assert(data_p->ins_type == INS_MC);
    return data_p->next_frame;
};

long ins_get_totalframe(GNode* node_p) {
    mc_ins_t 		*data_p = (mc_ins_t*)(node_p->data);
    struct MovieClip 	*def_p  = (struct MovieClip*)(data_p->define_p);

    assert(data_p->ins_type == INS_MC);
    return def_p->TotalFrames;
};

float ins_get_alpha(GNode* node_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    return data_p->cxform.AlphaMultTerm*100;
};

void ins_set_alpha(GNode* node_p,float value) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    data_p->cxform.AlphaMultTerm = value/100;
    data_p->dirty = TRUE;
};

long ins_get_width(GNode* node_p) {
    instance_t 	*data_p = (instance_t*)(node_p->data);
    //XXX ˶תǶ,׼
    return (data_p->boundary.Xmax - data_p->boundary.Xmin )/ TWIPS_PER_POINT;
};

void ins_set_width(GNode* node_p,long value);
long ins_get_height(GNode* node_p);
void ins_set_height(GNode* node_p,long value);
float ins_get_rotation(GNode* node_p) {}
;
void  ins_set_rotation(GNode* node_p,float value) {}
;
