#ifndef _MOVIE_CLIP_DEF_H_
#define _MOVIE_CLIP_DEF_H_

#include "base_types.h"

struct ActionBlock {
    // ο swftools ó.
#define	TClipEventKeyupP	0x80
#define	TClipEventKeyDownP	0x40
#define TClipEventMouseUpP	0x20
#define TClipEventMouseDownP	0x10
#define TClipEventMouseMoveP	0x8
#define TClipEventUnloadP	0x4
#define TClipEventEnterFrameP	0x2
#define TClipEventLoadP		0x1
#define TClipEventDragOverP	0x8000
#define TClipEventRollOutP	0x4000
#define TClipEventRollOverP	0x2000
#define TClipEventReleaseOutsideP	0x1000
#define TClipEventReleaseP	0x800
#define TClipEventPressP	0x400
#define	TClipEventInitializeP	0x200
#define TClipEventDataP		0x100
#define TClipEventConstructP	0x40000
#define TClipEventDragOutP	0x10000
#define TClipEventKeyPressP	0x20000	// 128 ֿܵİ¼

    // 146 ֿܵ¼
    struct ActionRecord*	ClipEventKeyupP;
    struct ActionRecord* 	ClipEventKeyDownP;
    struct ActionRecord* 	ClipEventMouseUpP;
    struct ActionRecord* 	ClipEventMouseDownP;
    struct ActionRecord* 	ClipEventMouseMoveP;
    struct ActionRecord* 	ClipEventUnloadP;
    struct ActionRecord* 	ClipEventEnterFrameP;
    struct ActionRecord* 	ClipEventLoadP;
    struct ActionRecord* 	ClipEventDragOverP;
    struct ActionRecord* 	ClipEventRollOutP;
    struct ActionRecord* 	ClipEventRollOverP;
    struct ActionRecord* 	ClipEventReleaseOutsideP;
    struct ActionRecord* 	ClipEventReleaseP;
    struct ActionRecord* 	ClipEventPressP;
    struct ActionRecord* 	ClipEventInitializeP;
    struct ActionRecord* 	ClipEventDataP;
    struct ActionRecord* 	ClipEventConstructP;
    struct ActionRecord* 	ClipEventDragOutP;
    struct ActionRecord* 	ClipEventKeyPressP[128];	// 128 ֿܵİ¼
};

//ڲϼӶ  PlaceObject  PlaceObject2
struct PlaceObject {
    struct PAndRObjects*	NextP;
    UI16                        Depth;
    UI8				PlaceAndRemoveType;
    UI8				Flags;
#define   PlaceFlagHasClipActions	0x1<<7
#define   PlaceFlagHasClipDepth		0x1<<6
#define   PlaceFlagHasName		0x1<<5
#define   PlaceFlagHasRatio		0x1<<4
#define   PlaceFlagHasColorTransform	0x1<<3
#define   PlaceFlagHasMatrix		0x1<<2
#define   PlaceFlagHasCharacter		0x1<<1
#define   PlaceFlagMove			0x1<<0

    UI16                        CharacterID;
    struct Matrix               Matrix;
    struct CxFormWithAlpha      ColorTransform;
    UI16                        Ratio;
    UI16                        ClipDepth;
    struct ActionBlock		*ActionBlockP;
    STRING			NameP;
};

//Ƴ  RemoveObject  RemoveObject2
struct RemoveObject {
    struct PAndRObjects*	NextP;
    UI16                Depth;
    UI8			PlaceAndRemoveType;
    UI16                CharacterID;
};

struct PAndRObjects {
    struct PAndRObjects*	NextP;
    UI16                        	Depth;
#define	  TPlaceObjectOne	 	0x11
#define	  TPlaceObjectTwo	 	0x12
#define	  TRemoveObjectOne 		0x21
#define	  TRemoveObjectTwo 		0x22

    UI8					PlaceAndRemoveType;
};

struct FrameLabel {
    struct FrameLabel*	NextP;
    STRING		NameP;
    UI16		Frame;
};

// һ Frame Ͽɹණ, ͼ,ͽű
struct Frame {
    // ͼ
    struct PAndRObjects*	TagsListP;	//  PlaceObject  RemoveObject ɵ.

    //  XXX ٶһ frame ֻһһ¼
    struct SoundStreamHead*	SoundStreamHeadP;//  Frame ʽ,ɹ ͷ.
    struct SoundStreamBlock*	SoundStreamBlockP;	//  Frame ʽ,ɹ .
    struct StartSound*		EventSoundP;	//  Frame ¼,ɹ StartSound.

    // ű
    struct ActionRecord*	FrameEventP;	// ڴ Frame ϵĽű.
};

//   Sprite ɱΪ MovieClip
struct MovieClip {
    UI8				CharacterType; //= CharMovieClip;
    UI16			CharacterID;
    struct FrameLabel*		FrameLabelListP;		//Frame Ƶ Frame ŵĶ
    UI32			TotalFrames;			//֡

    // Frame 
    struct Frame		Frames[1];
};
#endif
