#include "matrix.h"
#include "rect.h"
long getrectWidth(Rect rect) {
    return rect.Xmax-rect.Xmin;
};

long getrectHeight(Rect rect) {
    return rect.Ymax-rect.Ymin;
};

/*void print() {
  printf("Xmin = %d   Xmax = %d  Ymin = %d  Ymax = %d\n",
  (int)xmin,(int)xmax,(int)ymin,(int)ymax);
  };*/

void resetrect(Rect *rect) {
    rect->Xmin = LONG_MAX;
    rect->Ymin = LONG_MAX;
    rect->Xmax = LONG_MIN;
    rect->Ymax = LONG_MIN;

}
void bbox(Rect *rect, Matrix *m, long x1, long y1) {
    long x,y;

    x = getX(m,x1,y1);
    y = getY(m,x1,y1);
    //printf("x is %ld,y is %ld\n",x1,y1);
    //printf("rect.xmin=%ld, rect.xmax=%ld,rect.ymin=%ld,rect.ymax=%ld\n",rect->Xmin,rect->Ymin,rect->Xmax,rect->Ymax);
    if (x < rect->Xmin)
        rect->Xmin = x;
    if (x > rect->Xmax)
        rect->Xmax = x;
    if (y < rect->Ymin)
        rect->Ymin = y;
    if (y > rect->Ymax)
        rect->Ymax = y;
}

// Update bb to include boundary, optional reset of bb
void transformBoundingBox(Rect *bb, Matrix *matrix, Rect *boundary, int reset) {
    if (reset) {
        resetrect(bb);
    }
    // //printf("xmin=%ld, xmax=%ld,ymin=%ld,ymax=%ld\n",bb->Xmin,bb->Xmax,bb->Ymin,bb->Ymax);
    if (boundary->Xmin != LONG_MAX) {
        bbox(bb, matrix, boundary->Xmin, boundary->Ymin);
        bbox(bb, matrix, boundary->Xmax, boundary->Ymin);
        bbox(bb, matrix, boundary->Xmin, boundary->Ymax);
        bbox(bb, matrix, boundary->Xmax, boundary->Ymax);
    }
}
