#include <math.h>
#include <stdlib.h>
#include "config.h"
#include "render_shape.h"
#include "render_rend.h"
#include "bitmap_def.h"
#include "base_types.h"
#include "cxform.h"
#include "matrix.h"
#include "rect.h"
#include "xwin_pub.h"
#if WITH_DMALLOC
#include <dmalloc.h>
#endif

extern player_t 	*player_p;
#define PRINT 0

#define ABS(v) ((v) < 0 ? -(v) : (v))
ShapeDef  shapedef;
//shapedef=(ShapeDef *)malloc(sizeof(ShapeDef));
void prepareStyles(GraphicDevice *gd2, Matrix *matrix, Cxform *cxform, FillStyleDef *f, long n);

void clearStyles(GraphicDevice *gd2, FillStyleDef *f, long n);

void drawShape(GraphicDevice *gd2, Matrix *matrix1, Cxform *cxform, Shape *shape,ShapeDef *shapedef,ShapeAction shapeAction, void *id,ScanLineFunc scan_line_func);

void shapeGetBoundingBox(Shape *shape,Rect *bb) {
    *bb =  shape->ShapeBounds;
}
//shapeȾڳ
int shapeexecute(GraphicDevice *gd2,Shape *shape, Matrix *matrix, Cxform *cxform) {
    //ShapeDef  *shapedef;
    //shapedef=(ShapeDef *)malloc(sizeof(ShapeDef));
    //if(!shapedef)

    shapedef.defaultFillStyle.FillStyleType = f_Solid;
    shapedef.defaultFillStyle.Color.Red = 0;
    shapedef.defaultFillStyle.Color.Green = 0;
    shapedef.defaultFillStyle.Color.Blue = 0;
    shapedef.defaultFillStyle.Color.Alpha = ALPHA_OPAQUE;

    shapedef.defaultLineStyle.Width = 0;

    // This is to force a first update
    shapedef.lastMat.ScaleX = 0;
    shapedef.lastMat.ScaleY = 0;
    //shapedef.getStyles = 0;
    shapedef.getAlpha = 0;

    if (cxform) {
        //printf("to cxform side\n");
        shapedef.defaultFillStyle.Color = getColor(cxform,getForegroundColor(gd2));
    } else {
        shapedef.defaultFillStyle.Color = getForegroundColor(gd2);
    }
    shapedef.defaultFillStyle.Color.pixel = allocColor16(gd2,shapedef.defaultFillStyle.Color);
    // //printf("to execute \n");
    //printf("sscalex is %f,sscaley is %f,srotateskew0 is %f,srotateskew1 is %f,stranslatex is %ld,stranslatey is %ld,\n",matrix->ScaleX,matrix->ScaleY,matrix->RotateSkew0,matrix->RotateSkew1,matrix->TranslateX,matrix->TranslateY);
    drawShape(gd2, matrix, cxform, shape,&shapedef, ShapeDraw, NULL, 0);
    return 0;
}

void
shapeGetRegion(GraphicDevice *gd2, Shape *shape,Matrix *matrix, void *id, ScanLineFunc scan_line_func) {
    setClipping(gd2,0);
    //drawShape(gd2,matrix,0,shape,ShapeGetRegion,id,scan_line_func);
    setClipping(gd2,1);
}



// ʼһµ·

static void newPath(ShapeParser *shape,long x,long y ) {
    Path *p;
    long x1,y1;

    p=&shape->curPath;
    //printf("Scalex is %f scaley is %f Rota0 is %f rota1 is %f  tx is %ld ty is %ld\n",shape->matrix->ScaleX,\
    shape->matrix->ScaleY,shape->matrix->RotateSkew0,shape->matrix->RotateSkew1,shape->matrix->TranslateX,shape->matrix->TranslateY);
    x1 = getX(shape->matrix,x, y);
    y1 = getY(shape->matrix,x, y);

    p->lastX = x1;
    p->lastY = y1;
    //printf("newpath p->lastX is %ld p->lastY is %ld\n",p->lastX, p->lastY);
    p->nb_edges = 0;
    p->nb_segments = 0;
}


static void addSegment1(ShapeParser *shape,
                        long x, long y,
                        FillStyleDef *f0,
                        FillStyleDef *f1,
                        LineStyleDef *l) {
    Path *p;
    p=&shape->curPath;

    //printf("in addsegment1\n");
    if (l) {
        /* a line is defined ... it will be drawn later */
        LineSegment *ls;

        ls = (LineSegment*) malloc(sizeof(struct LineSegment));
        if (ls != NULL) {
            ls->l = l;
            ls->x1 = p->lastX;
            ls->y1 = p->lastY;
            ls->x2 = x;
            ls->y2 = y;
            ls->first = (p->nb_segments == 0);
            ls->next = NULL;
            if (shape->last_line == NULL) {
                shape->first_line = ls;
            } else {
                shape->last_line->next = ls;
            }
            shape->last_line = ls;
        }
    }
    //  //printf("addsegment1 red is %d green is %d blue is %d\n",l->ColorRGB.Red,l->ColorRGB.Green,l->ColorRGB.Blue);
    /* anti antialiasing not needed if line */
    if (!shape->reverse) {
        //  printf("1lastx is %ld last y is %ld x is %ld y is %ld\n",p->lastX,p->lastY,x,y);
        addSegment(shape->gd,p->lastX,p->lastY,x,y,f0,f1,l ? 0 : 1);
    } else {
        //   printf("2lastx is %ld last y is %ld x is %ld y is %ld\n",p->lastX,p->lastY,x,y);
        addSegment(shape->gd,p->lastX,p->lastY,x,y,f1,f0,l ? 0 : 1);
    }

    p->lastX = x;
    p->lastY = y;

    p->nb_segments++;
}


static void addLine(ShapeParser *shape, long x, long y,
                    FillStyleDef *f0,
                    FillStyleDef *f1,
                    LineStyleDef *l) {
    long x1,y1;
    Path *p;

    p=&shape->curPath;

    x1 = getX(shape->matrix,x, y);
    y1 = getY(shape->matrix,x, y);
    //printf("aaaaaaaaaaa x1 is %ld y1 is %ld\n",x1,y1);
    addSegment1(shape,x1,y1,f0,f1,l);

    p->nb_edges++;
}


// This is based on Divide and Conquer algorithm.

#define BFRAC_BITS  0
#define BFRAC       (1 << BFRAC_BITS)

static void
bezierBuildPoints (ShapeParser *s,
                   int subdivisions,
                   long a1X, long a1Y,
                   long cX, long cY,
                   long a2X, long a2Y) {
    long c1X,c1Y;
    long c2X,c2Y;
    long X,Y;
    long xmin,ymin,xmax,ymax;

    if (subdivisions != 0) {

        /* find the bounding box */

        if (a1X < cX) {
            xmin = a1X;
            xmax = cX;
        } else {
            xmin = cX;
            xmax = a1X;
        }
        if (a2X < xmin)
            xmin = a2X;
        if (a2X > xmax)
            xmax = a2X;

        if (a1Y < cY) {
            ymin = a1Y;
            ymax = cY;
        } else {
            ymin = cY;
            ymax = a1Y;
        }
        if (a2Y < ymin)
            ymin = a2Y;
        if (a2Y > ymax)
            ymax = a2Y;

        if (((xmax - xmin) + (ymax - ymin)) >= (BFRAC*FRAC*2)) {
            // Control point 1
            c1X = (a1X+cX) >> 1;
            c1Y = (a1Y+cY) >> 1;

            // Control point 2
            c2X = (a2X+cX) >> 1;
            c2Y = (a2Y+cY) >> 1;

            // New point
            X = (c1X+c2X) >> 1;
            Y = (c1Y+c2Y) >> 1;

            subdivisions--;

            bezierBuildPoints(s, subdivisions,
                              a1X, a1Y, c1X, c1Y, X, Y);
            bezierBuildPoints(s, subdivisions,
                              X, Y, c2X, c2Y, a2X, a2Y);

            return;
        }
    }

    addSegment1(s, (a2X+(BFRAC/2)) >> BFRAC_BITS,
                (a2Y+(BFRAC/2)) >> BFRAC_BITS, s->f0, s->f1, s->l);
}

/* ǰ· */
void flushPaths(ShapeParser *s) {
    GraphicDevice *gd2;
    LineSegment *ls;
    struct LineStyle *l;
    FillStyleDef  *linefill;
    long nx,ny,nn,w;
    linefill=0;
    linefill=(FillStyleDef *)malloc(sizeof(FillStyleDef));
    linefill->FillStyleType = f_Solid;

    gd2 = s->gd;
    //printf("in flushpath\n");
    /* draw the filled polygon */
    drawPolygon(gd2);
    //printf("in flushpath after drawpolygon\n");

    /*	long k=0;
    	for (k=0;k<999999990;k++)
    	{k=k;}
      */
    /* draw the lines */
    ls = s->first_line;
    if (ls != NULL) {
        do {
            l = ls->l;
            /*Color bb;
            bb.Red=6;
            bb.Green=29;
            bb.Blue=60;
            //bb=l->ColorRGB;

            //Color bb;
            //l->ColorRGB=bb;
                                 linefill->Color = bb;//l->ColorRGB;

            #if 0                    
            //printf("line %d %d %d %d width=%d\n",
            		ls->x1, ls->y1, ls->x2, ls->y2, l->width);
            #endif

             XXX: this width is false, but it is difficult (and expensive)
               to have the correct one */
            linefill->Color=l->RendColor;
            // linefill->Color=l->ColorRGB;
            //linefill->Color.pixel = allocColor16(gd2,linefill->Color);
            w = ABS((long)(s->matrix->ScaleX*l->Width));//l->Width));

            if (w <= ((3*FRAC)/2)) {
                w = FRAC;
            }
#ifdef THIN_LINES
            if (w <= ((3*FRAC)/2)) {
                // draw the thin lines only in shapeAction == shapeDraw
                if (gd2->scan_line_func == NULL) {
                    setForegroundColor(gd2,l->fillstyle.color);

                    drawLine(gd2,ls->x1, ls->y1, ls->x2, ls->y2, w);
                }
            } else {
#else
            {
#endif
                /* compute the normal vector */

                nx = -(ls->y2 - ls->y1);
                ny = (ls->x2 - ls->x1);

                /* normalize & width */
                nn = 2 * (long) sqrt(nx * nx + ny * ny);

#define UL ls->x1 + nx -ny, ls->y1 + ny +nx
#define UR ls->x2 + nx +ny, ls->y2 + ny -nx
#define LL ls->x1 - nx -ny, ls->y1 - ny +nx
#define LR ls->x2 - nx +ny, ls->y2 - ny -nx

                if (nn > 0) {
                    nx = (nx * w) / nn;
                    ny = (ny * w) / nn;

                    /* top segment */
                    addSegment(gd2,UL, UR, NULL, linefill, 1);

                    /* bottom segment */
                    addSegment(gd2,LL, LR, linefill, NULL, 1);

                    /* right segment */
                    addSegment(gd2,UR, LR, linefill, NULL, 1);

                    /* left segment */
                    addSegment(gd2,UL, LL, NULL, linefill, 1);

                    /* draw the line polygon */
                    //printf("to drawline\n");
                    drawPolygon(gd2);
                    //printf("one line  end\n");
                }
            }

            ls = ls->next;
        }
        while (ls != NULL)
            ;

        /* delete the line structures */

        ls = s->first_line;
        while (ls != NULL) {
            LineSegment *ls1;
            ls1 = ls->next;
            free(ls);
            ls = ls1;
        }

        /* reset the line pointers */
        s->first_line = NULL;
        s->last_line = NULL;
    }
    //printf("out of flushpath\n");
    if(linefill)
        free(linefill);
}


static void addBezier(ShapeParser *shape,
                      long ctrlX1, long ctrlY1,
                      long newX1, long newY1,
                      FillStyleDef *f0,
                      FillStyleDef *f1,
                      LineStyleDef *l) {
    long newX,newY,ctrlX,ctrlY;
    Path *p;

    p=&shape->curPath;

    /* note: we do the matrix multiplication before calculating the
       bezier points (faster !) */

    ctrlX = getX(shape->matrix,ctrlX1, ctrlY1);
    ctrlY = getY(shape->matrix,ctrlX1, ctrlY1);
    newX = getX(shape->matrix,newX1, newY1);
    newY = getY(shape->matrix,newX1, newY1);

    shape->f0 = f0;
    shape->f1 = f1;
    shape->l = l;

    bezierBuildPoints(shape, 3,
                      p->lastX<<BFRAC_BITS,p->lastY<<BFRAC_BITS,
                      ctrlX<<BFRAC_BITS,ctrlY<<BFRAC_BITS,
                      newX<<BFRAC_BITS,newY<<BFRAC_BITS);

    p->nb_edges++;
}

//ҪshapeȾ
void drawShape(GraphicDevice *gd2, Matrix *matrix1, Cxform *cxform, Shape *shape,ShapeDef *shapedef,
               ShapeAction shapeAction, void *id,ScanLineFunc scan_line_func) {  //printf("to drawshape\n");
    int loop;
    int endshape;
    struct StyleChangeRecord *st;
    struct CurvedEdgeRecord *stc;
    struct StraightEdgeRecord *sts;
    LineStyleDef *l;
    FillStyleDef *f0;
    FillStyleDef *f1;
    ShapeRecord sr1,*sr = &sr1;
    int firstPoint;
    long lastX,lastY;
    LineStyleDef *curLineStyle;
    long curNbLineStyles;
    FillStyleDef *curFillStyle;
    long curNbFillStyles;
    StyleList *sl;
    ShapeParser sp1,*sp=&sp1;
    // BitParser *b;
    Matrix     mat,*matrix;
    //printf("sssscalex is %f,ssscaley is %f,ssrotateskew0 is %f,ssrotateskew1 is %f,sstranslatex is %ld,sstranslatey is %ld,\n",matrix1->ScaleX,matrix1->ScaleY,matrix1->RotateSkew0,matrix1->RotateSkew1,matrix1->TranslateX,matrix1->TranslateY);
    mat = MatrixMulti((gd2->adjust) , (matrix1));
    //printf("ssscalex is %f,ssscaley is %f,ssrotateskew0 is %f,ssrotateskew1 is %f,sstranslatex is %ld,sstranslatey is %ld,\n",mat.ScaleX,mat.ScaleY,mat.RotateSkew0,mat.RotateSkew1,mat.TranslateX,mat.TranslateY);
    matrix = &mat;

    sp->reverse = (mat.ScaleX * mat.RotateSkew1) < 0;
    endshape=0;
    curLineStyle = NULL;
    curNbLineStyles = 0;
    curFillStyle = NULL;
    curNbFillStyles = 0;
    sp->style_list = NULL;

    sp->shape = shape;
    sp->gd = gd2;
    sp->matrix = matrix;
    sp->cxform = cxform;
    //   sp->dict = shape->dict;

    if (shapeAction == ShapeGetRegion) {
        gd2->scan_line_func = scan_line_func;
        gd2->scan_line_func_id = id;
    } else {
        gd2->scan_line_func = NULL;
    }

    //  b = &sp->bit_parser;
    // InitBitParser(b,shape->file_ptr);

    if (shapedef->getStyles) {

        //printf("to getstyles\n");
        // ShapeWithStyle
        //curFillStyle = shape->FillStylesP->FillStyles;//ParseFillStyle(sp, &curNbFillStyles, shape->getAlpha);
        curNbFillStyles=shape->FillStylesP->count;
        if (curNbFillStyles > 0) {

            curFillStyle=(FillStyleDef *)malloc(curNbFillStyles*sizeof(FillStyleDef));
            if (curFillStyle == NULL)
                return;
            for(loop=0;loop<curNbFillStyles;loop++)
                curFillStyle[loop]=shape->FillStylesP->FillStyles[loop];
        };
        //printf("currentnbfillstyles is %ld \n",curNbFillStyles);

        // if (curFillStyle == NULL) return;
        //curLineStyle = shape->LineStylesP->LineStyles;//ParseLineStyle(sp, &curNbLineStyles, shape->getAlpha);
        curNbLineStyles=shape->LineStylesP->count;
        if (curNbLineStyles > 0) {
            curLineStyle=(LineStyleDef *)malloc(curNbLineStyles*sizeof(LineStyleDef));
            if (curLineStyle == NULL)
                return;
            for(loop=0;loop<curNbLineStyles;loop++) {
                curLineStyle[loop]=shape->LineStylesP->LineStyles[loop];
                curLineStyle[loop].RendColor=curLineStyle[loop].ColorRGB;
                if (cxform)
                    curLineStyle[loop].RendColor = getColor(cxform,curLineStyle[loop].RendColor);
                curLineStyle[loop].RendColor.pixel=allocColor16(gd2,curLineStyle[loop].RendColor);
            }
        };
        //if (curLineStyle == NULL) return;
        sl = (StyleList*)malloc(sizeof(StyleList));
        if (sl == NULL)
            return;

        sl->next = NULL;
        sl->newFillStyles = curFillStyle;
        sl->nbNewFillStyles = curNbFillStyles;
        sl->newLineStyles = curLineStyle;
        sl->nbNewLineStyles = curNbLineStyles;

        sp->style_list = sl;

        if (shapeAction == ShapeDraw) {
            prepareStyles(gd2, matrix, cxform, curFillStyle, curNbFillStyles);
        }
    }

    /* InitBits(b);
       sp->m_nFillBits = (U16) GetBits(b,4);
       sp->m_nLineBits = (U16) GetBits(b,4);
     */
    l = 0;
    f0 = 0;
    f1 = 0;
    firstPoint = 1;
    lastX = 0;
    lastY = 0;
    sp->curPath.nb_edges = 0;
    sp->first_line = NULL;
    sp->last_line = NULL;
    // sr=shape->ShapeRecordsP;
    //for(sr=shape->ShapeRecordsP;sr->flags!=end;sr=sr->nextP) {
    //if (ParseShapeRecord(sp, sr, shape->getAlpha) == 0) break;
    //¼ѭ


    sr=shape->ShapeRecordsP;//->NextP;
    for(;sr;sr=sr->NextP) {
        // if(endshape==1) break;
        //printf("sr->Flags is %d\n",sr->Flags);
        if(sr->Flags==TCurvedEdge) { //printf("to curve\n");
            // Handle Bezier Curves !!!
            stc=(struct CurvedEdgeRecord *)sr;
            if (firstPoint) {
                newPath(sp, 0, 0);
                firstPoint = 0;
            }
            {
                long newX,newY,ctrlX,ctrlY;

                ctrlX = lastX+stc->ControlDeltaX;
                ctrlY = lastY+stc->ControlDeltaY;
                newX = ctrlX+stc->AnchorDeltaX;
                newY = ctrlY+stc->AnchorDeltaY;

#if 1

                addBezier(sp, ctrlX, ctrlY, newX, newY, f0 , f1, l);
#else

                addLine(sp, newX, newY, f0, f1, l);
#endif

                lastX = newX;
                lastY = newY;
            }
            continue;
        }

        if(sr->Flags==TStraightEdge) {
            sts=(struct StraightEdgeRecord *)sr;
            if (firstPoint) {
                newPath(sp, 0, 0);
                firstPoint = 0;
            }
            if(sts->StraightLineFlag) {
                // printf("deltax is %ld ,deltay is %ld\n",sts->StraightLineDeltaX,sts->StraightLineDeltaY);
                lastX += sts->StraightLineDeltaX;
                lastY += sts->StraightLineDeltaY;
            } else {
                if(sts->VertLineFlag) {
                    lastX +=0;
                    lastY += sts->VertLineDeltaY;
                } else {
                    lastX +=sts->HorLineDeltaX;
                    lastY +=0;
                }
            }
            //printf("line to  x is %ld,y is %ld\n",sts->StraightLineDeltaX,sts->StraightLineDeltaY);
            // printf("to addline\n");
            // printf("lastx is %ld last y is %ld\n",lastX,lastY);
            addLine(sp, lastX, lastY, f0, f1, l);
            //printf("out of addline\n");
#if PRINT
            //printf(" X, Y  = %4d,%4d\n", lastX/20, lastY/20);
#endif

            continue;
        }

        if (sr->Flags&0x10) {//printf("to newstyles\n");
            // struct StyleChangeRecord *st;
            st=(struct StyleChangeRecord *)sr;
            // struct StyleChangeRecord *s1;
            // int x;
            // s1=(struct StyleChangeRecord *)sr;
            // struct StyleChangeRecord sr1,*sr=&sr1;

            // (struct StyleChangeRecord *)sr;

            /*curFillStyle = st->FillStylesP->FillStyles;
            curNbFillStyles = st->FillStylesP->count;
            curLineStyle = st->LineStylesP->LineStyles;
            curNbLineStyles = st->LineStylesP->count;*/

            sl =  (StyleList*)malloc(sizeof(StyleList));
            sl->next = sp->style_list;
            curNbFillStyles=st->FillStylesP->count;

            if (curNbFillStyles > 0) {
                curFillStyle=(FillStyleDef *)malloc(curNbFillStyles*sizeof(FillStyleDef));
                if (curFillStyle == NULL)
                    return;
                for(loop=0;loop<curNbFillStyles;loop++)
                    curFillStyle[loop]=st->FillStylesP->FillStyles[loop];
            }
            if (curNbFillStyles == 0)
                curFillStyle=0;
            curNbLineStyles=st->LineStylesP->count;
            if (curNbLineStyles > 0) {
                curLineStyle=(LineStyleDef *)malloc(curNbLineStyles*sizeof(LineStyleDef));
                if (curLineStyle == NULL)
                    return;
                for(loop=0;loop<curNbLineStyles;loop++) {
                    curLineStyle[loop]=st->LineStylesP->LineStyles[loop];
                    curLineStyle[loop].RendColor=curLineStyle[loop].ColorRGB;
                    if (cxform)
                        curLineStyle[loop].RendColor = getColor(cxform,curLineStyle[loop].RendColor);
                    curLineStyle[loop].RendColor.pixel=allocColor16(gd2,curLineStyle[loop].RendColor);
                }
            };
            if (curNbLineStyles == 0)
                curLineStyle=0;

            sl->newFillStyles = curFillStyle;
            sl->nbNewFillStyles = curNbFillStyles;
            sl->newLineStyles = curLineStyle;
            sl->nbNewLineStyles = curNbLineStyles;

            sp->style_list = sl;

            if (shapeAction == ShapeDraw) {
                prepareStyles(gd2, matrix, cxform, curFillStyle, curNbFillStyles);
            }

        }
        if (sr->Flags&0x02) {
            {
                st=(struct StyleChangeRecord *)sr;
                if (st->FillStyle0) {
                    if (curFillStyle) {//printf("to fillstyle0 is %d\n",st->FillStyle0);
                        f0 = &curFillStyle[st->FillStyle0-1];

                        //gd2->gindex=st->FillStyle0;
                        //printf("f0 alpha is %d\n",f0->Color.Alpha);
                    } else {//printf("to defaultfillstyle0\n");
                        f0 = &shapedef->defaultFillStyle;
                    }
                } else {
                    f0 = 0;
                }
            }
        }
        if (sr->Flags&0x04) { //printf("to fillstyle1\n");
            {st=(struct StyleChangeRecord *)sr;
                if (st->FillStyle1) {
                    if (curFillStyle) {//printf("fillstyle1 is %ld\n",st->FillStyle1);

                        f1 = &curFillStyle[st->FillStyle1-1];

                        //gd2->gindex=st->FillStyle1;
                        //printf("f1 alpha is %d\n",f1->Color.Alpha);
                        //printf("shape bitmap id is %d\n",f1->BitmapId);
                    } else {
                        f1 = &shapedef->defaultFillStyle;
                    }
                } else {
                    f1 = 0;
                }
            }
        }
        if (sr->Flags&0x08) { //printf("to linestyel\n");
            {st=(struct StyleChangeRecord *)sr;
                if (st->LineStyle) {
                    l = &curLineStyle[st->LineStyle-1];


                    //if(!l)
                    //printf("l is null\n");
                } else {
                    l = 0;
                }
            }
        }
        if (sr->Flags&0x01) {//printf("to move to\n");
            {st=(struct StyleChangeRecord *)sr;
                if (sp->curPath.nb_edges == 0) {


                    flushPaths(sp);
                }
                //printf("move to x is %ld,y is %ld\n",st->MoveDeltaX,st->MoveDeltaY);
                //printf("newpath detax is %ld detay is %ld\n",st->MoveDeltaX, st->MoveDeltaY);
                newPath(sp, st->MoveDeltaX, st->MoveDeltaY);
                firstPoint = 0;

                lastX = st->MoveDeltaX;
                lastY = st->MoveDeltaY;

#if PRINT
                //printf("---------\nX,Y    = %4d,%4d\n", sr->x/20, sr->y/20);
#endif

            }

        }

        /*switch (sr->Flags)//type
        {
        	case (StateNewStyles&0x10):
        	  //printf("to newstyles\n");
        		// struct StyleChangeRecord *st;
        		st=(struct StyleChangeRecord *)sr;
        		// struct StyleChangeRecord *s1;
        		// int x;
        		// s1=(struct StyleChangeRecord *)sr;
        		// struct StyleChangeRecord sr1,*sr=&sr1;
        		
        			// (struct StyleChangeRecord *)sr;

        			curFillStyle = st->FillStylesP->FillStyles;
        			curNbFillStyles = st->FillStylesP->count;
        			curLineStyle = st->LineStylesP->LineStyles;
        			curNbLineStyles = st->LineStylesP->count;

        			sl =  (StyleList*)malloc(sizeof(StyleList));
        			sl->next = sp->style_list;
        			sl->newFillStyles = st->FillStylesP->FillStyles;
        			sl->nbNewFillStyles = st->FillStylesP->count;
        			sl->newLineStyles = st->LineStylesP->LineStyles;
        			sl->nbNewLineStyles = st->LineStylesP->count;

        			sp->style_list = sl;

        			if (shapeAction == ShapeDraw) {
        				prepareStyles(gd2, matrix, cxform, curFillStyle, curNbFillStyles);
        			}
        		break;
        		case (StateFillStyle0&0x02): 
        		 //printf("to fillstyle0\n");
        		{st=(struct StyleChangeRecord *)sr;
        			if (st->FillStyle0) {
        				if (curFillStyle) {
        					f0 = &curFillStyle[st->FillStyle0-1];
        				} else {
        					f0 = &shapedef->defaultFillStyle;
        				}
        			} else {
        				f0 = 0;
        			}
        		}
        		break;
        		case (StateFillStyle1&0x04):
        		 //printf("to fillstyle1\n");
        		 {st=(struct StyleChangeRecord *)sr;
        			if (st->FillStyle1) {
        				if (curFillStyle) {
        					f1 = &curFillStyle[st->FillStyle1-1];
        				} else {
        					f1 = &shapedef->defaultFillStyle;
        				}
        			} else {
        				f1 = 0;
        			}
        		}
        		break;
        		case (StateLineStyle&0x08):
        		 //printf("to linestyel\n");
        		 {st=(struct StyleChangeRecord *)sr;
        			if (st->LineStyle) {
        				l = &curLineStyle[st->LineStyle-1];
        			} else {
        				l = 0;
        			}
        		}
        		break;
        		case (StateMoveTo&0x01):
        		 //printf("to moveto\n");
        		{st=(struct StyleChangeRecord *)sr;
        			if (sp->curPath.nb_edges == 0) {
        				

        				flushPaths(sp);
        			}
                                       //printf("move to x is %ld,y is %ld\n",st->MoveDeltaX,st->MoveDeltaY); 
        			newPath(sp, st->MoveDeltaX, st->MoveDeltaY);
        			firstPoint = 0;

        			lastX = st->MoveDeltaX;
        			lastY = st->MoveDeltaY;

        #if PRINT
        			//printf("---------\nX,Y    = %4d,%4d\n", sr->x/20, sr->y/20);
        #endif
        		}
        		break;
        	case TCurvedEdge:
        		 //printf("to curve\n");
        		// Handle Bezier Curves !!!
        		stc=(struct CurvedEdgeRecord *)sr;
        		if (firstPoint) {
        			newPath(sp, 0, 0);
        			firstPoint = 0;
        		}
        		{
        			long newX,newY,ctrlX,ctrlY;

        			ctrlX = lastX+stc->ControlDeltaX;
        			ctrlY = lastY+stc->ControlDeltaY;
        			newX = ctrlX+stc->AnchorDeltaX;
        			newY = ctrlY+stc->AnchorDeltaY;

        #if 1
        			addBezier(sp, ctrlX, ctrlY, newX, newY, f0 , f1, l);
        #else
        			addLine(sp, newX, newY, f0, f1, l);
        #endif

        			lastX = newX;
        			lastY = newY;
        		}
        		break;
        	case TStraightEdge:
        	          
        		{
        			sts=(struct StraightEdgeRecord *)sr;
        			if (firstPoint) {
        				newPath(sp, 0, 0);
        				firstPoint = 0;
        			}
                                   
        			lastX += sts->StraightLineDeltaX;
        			lastY += sts->StraightLineDeltaY;
                                       //printf("line to  x is %ld,y is %ld\n",sts->StraightLineDeltaX,sts->StraightLineDeltaY); 
        			addLine(sp, lastX, lastY, f0, f1, l);
        #if PRINT
        			//printf(" X, Y  = %4d,%4d\n", lastX/20, lastY/20);
        #endif                              
        			
        			break;
        		}
        	
        		
        		
        }*/
    }
    /* XXX: should test if there is something to draw */

    flushPaths(sp);

    /* free the styles */
    while (sp->style_list) {
        StyleList *sl;

        sl=sp->style_list;
        sp->style_list = sl->next;

        if (shapeAction == ShapeDraw) {
            clearStyles(gd2, sl->newFillStyles, sl->nbNewFillStyles);
        }
        if(sl->newFillStyles)
            free(sl->newFillStyles);
        if(sl->newLineStyles)
            free(sl->newLineStyles);
        free(sl);
    }
    //printf("out of drawshape\n");
}

void
prepareStyles(GraphicDevice *gd2, Matrix *matrix, Cxform *cxform,
              FillStyleDef *ftab, long n) {
    long fs;
    FillStyleDef *f;
    static Matrix cc;
    static int bb;
    //printf("n is %ld\n",n);
    for(fs = 0; fs < n; fs++) {
        f = ftab + fs;
        //printf(" to prepre styles\n");
        switch (f->FillStyleType) {
        case f_None:
            break;
        case f_Solid:
            //printf("to solid \n");
            if (cxform) {
                //printf("solid cxform is true\n");
                //printf("red is %d green is %d blue is %d\n",f->Color.Red,f->Color.Green,f->Color.Blue);
                //printf("rm is %f gm is %f  bm is %f am is %f\n",cxform->RedMultTerm,cxform->GreenMultTerm,cxform->BlueMultTerm,cxform->AlphaMultTerm);
                //printf("ra is %ld ga is %ld  ba is %ld aa is %ld\n",cxform->RedAddTerm,cxform->GreenAddTerm,cxform->BlueAddTerm,cxform->AlphaAddTerm);
                //printf("solid alpha is %d\n",f->Color.Alpha);
                f->Color = getColor(cxform,f->Color);
                //printf("red is %d,green is %d,blue is %d\n",f->Color.Red,f->Color.Green,f->Color.Blue);
                //printf("after solid alpha is %d\n",f->Color.Alpha);
            }
            f->Color.pixel = allocColor16(gd2,f->Color);
            //printf("solid alpha is %d\n",f->Color.Alpha);
            //printf("solid prepare red is %d green is %d blue is %d\n",f->Color.Red,f->Color.Green,f->Color.Blue);
            break;
        case f_LinearGradient:
        case f_RadialGradient: {
                //printf("to gradient\n");

                Matrix mat;
                int  n,r,l;
                long red, green, blue, alpha;
                long dRed, dGreen, dBlue, dAlpha;
                long min,max;
                Matrix *m;

                //printf("scalex1 is %f,ssscaley is %f,ssrotateskew0 is %f,ssrotateskew1 is %f,sstranslatex is %ld,sstranslatey is %ld,\n",matrix->ScaleX,matrix->ScaleY,matrix->RotateSkew0,matrix->RotateSkew1,matrix->TranslateX,matrix->TranslateY);
                //printf("scalex2 is %f,ssscaley is %f,ssrotateskew0 is %f,ssrotateskew1 is %f,sstranslatex is %ld,sstranslatey is %ld,\n",f->GradientMatrix.ScaleX,f->GradientMatrix.ScaleY,f->GradientMatrix.RotateSkew0,f->GradientMatrix.RotateSkew1,f->GradientMatrix.TranslateX,f->GradientMatrix.TranslateY);
                mat = MatrixMulti((matrix),&(f->GradientMatrix));
                //printf("scalex3 is %f,ssscaley is %f,ssrotateskew0 is %f,ssrotateskew1 is %f,sstranslatex is %ld,sstranslatey is %ld,\n",mat.ScaleX,mat.ScaleY,mat.RotateSkew0,mat.RotateSkew1,mat.TranslateX,mat.TranslateY);
                // Compute inverted matrix
                f->GradientP->imat = invert(&mat);
                //printf("scalex4 is %f,ssscaley is %f,ssrotateskew0 is %f,ssrotateskew1 is %f,sstranslatex is %ld,sstranslatey is %ld,\n",gd2->g_imat.ScaleX,gd2->g_imat.ScaleY,gd2->g_imat.RotateSkew0,gd2->g_imat.RotateSkew1,gd2->g_imat.TranslateX,gd2->g_imat.TranslateY);
                /* renormalize the matrix */
                m=&f->GradientP->imat;
                if (f->FillStyleType == f_LinearGradient) {
                    m->ScaleX = m->ScaleX * FRAC * (1/128.0) * 65536.0;
                    m->RotateSkew0 = m->RotateSkew0 * FRAC * (1/128.0) * 65536.0;
                    m->TranslateX = (long) ((m->TranslateX + 16384) * (1/128.0) * 65536.0);
                } else {
                    m->ScaleX = m->ScaleX * FRAC * (1/64.0) * 65536.0;
                    m->RotateSkew0 = m->RotateSkew0 * FRAC * (1/64.0) * 65536.0;
                    m->RotateSkew1 = m->RotateSkew1 * FRAC * (1/64.0) * 65536.0;
                    m->ScaleY = m->ScaleY * FRAC * (1/64.0) * 65536.0;
                    m->TranslateX = (long) (m->TranslateX * (1/64.0) * 65536.0);
                    m->TranslateY = (long) (m->TranslateY * (1/64.0) * 65536.0);
                }

                // Reset translation in inverted matrix
                f->GradientP->g_has_alpha = 0;

                // Build a 256 color ramp
                f->GradientP->g_ramp = (Color *)malloc(256*sizeof(Color));
                if (f->GradientP->g_ramp == NULL) {
                    // Invalidate fill style
                    f->FillStyleType = f_None;
                    continue;
                }

                // Store min and max
                min = f->GradientP->GradientRecords[0].Ratio;
                max = f->GradientP->GradientRecords[f->GradientP->NumGradients-1].Ratio;
                //printf("min is %ld max is %ld\n",min,max);
                //this=f->GradientP->GadientRecords;
                //min =this->Ratio;
                for(r=0; r < f->GradientP->NumGradients-1; r++) {


                    //next=this->next;
                    Color start,end;
                    l = f->GradientP->GradientRecords[r+1].Ratio-f->GradientP->GradientRecords[r].Ratio;
                    //  l = next->Ratio-this->Ratio;
                    if (l == 0)
                        continue;

                    if (cxform) {
                        start = getColor(cxform,f->GradientP->GradientRecords[r].Color);
                        end   = getColor(cxform,f->GradientP->GradientRecords[r+1].Color);
                    } else {
                        start = f->GradientP->GradientRecords[r].Color;
                        end   = f->GradientP->GradientRecords[r+1].Color;

                    }
                    //printf("startalpha is %d\n",start.Alpha);

                    if (start.Alpha != ALPHA_OPAQUE ||
                            end.Alpha != ALPHA_OPAQUE) {
                        f->GradientP->g_has_alpha = 1;
                    }

                    dRed   = end.Red - start.Red;
                    dGreen = end.Green - start.Green;
                    dBlue  = end.Blue - start.Blue;
                    dAlpha = end.Alpha - start.Alpha;

                    dRed   = (dRed<<16)/l;
                    dGreen = (dGreen<<16)/l;
                    dBlue  = (dBlue<<16)/l;
                    dAlpha  = (dAlpha<<16)/l;

                    red   = start.Red <<16;
                    green = start.Green <<16;
                    blue  = start.Blue <<16;
                    alpha  = start.Alpha <<16;

                    //printf("red is %ld green is %ld blue is %ld  alpha is %ld \n",red,green,blue,alpha);
                    //printf("dred is %ld dgreen is %ld dblue is %ld  dalpha is %ld \n",dRed,dGreen,dBlue,dAlpha);
                    //printf("value is %d\n",f->GradientP->GradientRecords[r+1].Ratio);
                    for (n=f->GradientP->GradientRecords[r].Ratio; n<=f->GradientP->GradientRecords[r+1].Ratio; n++) {
                        f->GradientP->g_ramp[n].Red = red>>16;
                        f->GradientP->g_ramp[n].Green = green>>16;
                        f->GradientP->g_ramp[n].Blue = blue>>16;
                        f->GradientP->g_ramp[n].Alpha = alpha>>16;

                        f->GradientP->g_ramp[n].pixel = allocColor16(gd2,f->GradientP->g_ramp[n]);
                        red += dRed;
                        green += dGreen;
                        blue += dBlue;
                        alpha += dAlpha;

                    }


                }

                for(n=0; n<min; n++) {
                    f->GradientP->g_ramp[n] = f->GradientP->g_ramp[min];
                }
                for(n=max; n<256; n++) {
                    f->GradientP->g_ramp[n] = f->GradientP->g_ramp[max];
                }



                /*if(!(gd2->gradientrend))
                {
                gd2->gradientrend=(struct grend *)malloc(sizeof(struct grend));
                gd2->gradientrend->g_imat=gd2->g_imat;
                gd2->gradientrend->g_has_alpha=gd2->g_has_alpha;
                gd2->gradientrend->g_ramp=gd2->g_ramp;
                gd2->gradientrend->num=(fs+1);
                gd2->gradientrend->next=NULL;

                }
                else

                {

                gr=gd2->gradientrend;
                while(gr->next)
                gr=gr->next;
                gr->next=(struct grend *)malloc(sizeof(struct grend));
                //gd2->gradientrend->next=gr;
                gr=gr->next;
                if(gr)
                gr->g_imat=gd2->g_imat;
                gr->g_has_alpha=gd2->g_has_alpha;
                gr->g_ramp=gd2->g_ramp;
                gr->num=(fs+1);

                gr->next=NULL;
                }

                //gd2->g_ramp=NULL;*/
            }

            //printf("out of gradient\n");


            break;
        case f_TiledBitmap:

            //printf("to f_Tiledbitmap\n");
        case f_clippedBitmap: {
                int coun;
                Matrix *m;

                if(f->BitmapId==65535) {//cc=f->BitmapMatrix;
                    //printf("nousescalex is %f,sscaley is %f,srotateskew0 is %f,srotateskew1 is %f,stranslatex is %ld,stranslatey is %ld,\n",f->BitmapMatrix.ScaleX,f->BitmapMatrix.ScaleY,f->BitmapMatrix.RotateSkew0,f->BitmapMatrix.RotateSkew1,f->BitmapMatrix.TranslateX,f->BitmapMatrix.TranslateY);
                    continue;
                }
                //printf("to f_clipped_bitmap\n");
                if (f->BitmapId) {
                    //printf("bitmap id is %d\n",f->BitmapId);
                    struct DefineBitsJPEG  *tbitmap;
                    if(player_p->_level0_p->dict_p->dict[f->BitmapId]->CharacterType==CharBitsJPEG) {
                        //printf("to charbitsjpeg\n");
                        tbitmap=(struct DefineBitsJPEG *)(player_p->_level0_p->dict_p->dict[f->BitmapId]);
                    }
                    if(player_p->_level0_p->dict_p->dict[f->BitmapId]->CharacterType==CharBitsOne) {
                        //printf("to charbits\n");
                        tbitmap=(struct DefineBitsJPEG *)(player_p->_level0_p->dict_p->dict[f->BitmapId]);
                    }
                    if(player_p->_level0_p->dict_p->dict[f->BitmapId]->CharacterType==CharBitsLosslessOne) {
                        //printf("to charbitslosses\n");
                        tbitmap=(struct DefineBitsJPEG *)(player_p->_level0_p->dict_p->dict[f->BitmapId]);
                    }
                    // //printf("bitmapid is %d\n",f->BitmapId);
                    // //printf("bitmap is prepared here\n");
                    // (DictionaryP->dict[f->BitmapId])=0;

                    tbitmap=(struct DefineBitsJPEG *)(player_p->_level0_p->dict_p->dict[f->BitmapId]);

                    //printf("pixel is %d\n",DictionaryP->dict[f->BitmapId]->PixelsP[coun]);
                    //printf("bitmap is prepared here\n");
                    //Matrix *m;
                    //printf("id is %d \n",f->BitmapId);
                    // //printf("it is %ld \n",tbitmap->Colors);
                    //printf("oldred is %d oldgreen is %d  oldblue is %d\n",tbitmap->ColormapP[0].Red,tbitmap->ColormapP[0].Green,tbitmap->ColormapP[0].Blue);
                    f->cmap = getColormap(gd2,tbitmap->ColormapP, tbitmap->Colors, cxform);
                    /* for(coun=0;coun<(tbitmap->Colors);coun++)
                       //printf("spixel is %ld\n",gd2->cmap[coun].pixel);*/
                    //printf("it is %x\n",gd2->cmap);
                    if (f->cmap == NULL) { //printf("gd2->cmap is null \n");
                        //printf("gd2->cmap is null\n");
                        f->cmap = tbitmap->ColormapP;
                    }
                    //printf("scalex is %f,sscaley is %f,srotateskew0 is %f,srotateskew1 is %f,stranslatex is %ld,stranslatey is %ld,\n",f->BitmapMatrix.ScaleX,f->BitmapMatrix.ScaleY,f->BitmapMatrix.RotateSkew0,f->BitmapMatrix.RotateSkew1,f->BitmapMatrix.TranslateX,f->BitmapMatrix.TranslateY);
                    /* if(bb==0) cc=f->BitmapMatrix;
                      bb=bb+1;
                      f->BitmapMatrix=cc;*/
                    //f->BitmapMatrix=cc;
                    //gd2->BitmapMatrix=f->BitmapMatrix;
                    f->BitmapMatrix = MatrixMulti((matrix),&(f->BitmapMatrix));

                    f->BitmapMatrix = invert(&(f->BitmapMatrix));
                    //printf("scalex is %f,sscaley is %f,srotateskew0 is %f,srotateskew1 is %f,stranslatex is %ld,stranslatey is %ld,\n",f->BitmapMatrix.ScaleX,f->BitmapMatrix.ScaleY,f->BitmapMatrix.RotateSkew0,f->BitmapMatrix.RotateSkew1,f->BitmapMatrix.TranslateX,f->BitmapMatrix.TranslateY);
                    m=&f->BitmapMatrix;
                    m->ScaleX = m->ScaleX* FRAC * 65536.0;
                    m->RotateSkew0 = m->RotateSkew0 * FRAC * 65536.0;
                    m->RotateSkew1 = m->RotateSkew1 * FRAC * 65536.0;
                    m->ScaleY= m->ScaleY * FRAC * 65536.0;
                    m->TranslateX = (long) (m->TranslateX * 65536.0);
                    m->TranslateY = (long) (m->TranslateY * 65536.0);
                    //printf("mscalex is %f,sscaley is %f,srotateskew0 is %f,srotateskew1 is %f,stranslatex is %ld,stranslatey is %ld,\n",m->ScaleX,m->ScaleY,m->RotateSkew0,m->RotateSkew1,m->TranslateX,m->TranslateY);
                    f->alpha_table = NULL;

                    if (tbitmap->Alpha_bufP && cxform) {
                        unsigned char *alpha_table;
                        int i;
                        //printf("get alphatable\n");
                        alpha_table = (unsigned char *)malloc (256);
                        if (alpha_table != NULL) {
                            for(i=0;i<256;i++) {
                                alpha_table[i] = getAlpha(cxform,i);
                            }
                        }
                        f->alpha_table = alpha_table;
                    }
                }
            }
            break;
        }

    }
}

void
clearStyles(GraphicDevice *gd2, FillStyleDef *ftab, long n) {
    long fs;
    FillStyleDef *f;
    //printf("to clearstyle\n");
    for(fs = 0; fs < n; fs++) {
        f = ftab + fs;
        switch (f->FillStyleType) {
        case f_Solid:
            break;
        case f_LinearGradient:
        case f_RadialGradient: {
                if(f->GradientP->g_ramp)
                    free(f->GradientP->g_ramp);
                //printf("over clear style\n");
            }
            break;
        case f_TiledBitmap:
        case f_clippedBitmap: {
                struct DefineBitsJPEG  *tbitmap;
                if(f->BitmapId==65535)
                    continue;
                tbitmap=(struct DefineBitsJPEG *)(player_p->_level0_p->dict_p->dict[f->BitmapId]);
                // if (f->bitmap) {
                // if (gd2->cmap && gd2->cmap != ->bitmap->colormap)
                if(f->cmap&&(f->cmap!=tbitmap->ColormapP)) {//printf("to free cmap\n");
                    free(f->cmap);
                }
                //gd2->cmap=NULL;
                // free(gd2->cmap);
                if (f->alpha_table)
                    free(f->alpha_table);
                //   }
                //printf("over free bitmap\n");
            }
            break;
        case f_None:
            break;
        }
    }
}

