#ifndef _SOUND_MIXPLAY_H_
#define _SOUND_MIXPLAY_H_

#include <pthread.h>
#include <glib.h>
#include <inttypes.h>
#include "mpg123.h"
#include "mpglib.h"
#include "base_types.h"

/* 1. 
 * =========================
 * 
 * 1.1 
 * ---------
 * ģʹõݽṹ
 * 
 *         pcm_block_head
 *              | |
 * channel <- pcm_block -> pcm_block -> pcm_block 
 *              | |
 * channel <- pcm_block -> pcm_block 
 *              | |
 * channel <- pcm_block -> pcm_block -> pcm_block 
 *
 * ˫Ӹ channel ,
 * ÿеڵΪ channel Ľṹ,
 * ڵ㼰ҲΪ channel  pcm .
 * 
 * 1.2 
 * ---------
 * sound_init   ڳʼ豸.
 *
 * mix_and_play ϵĽеĸ channel 
 *              ϳ,.
 */

/* 2. ṹ˵
 * ==========================
 *
 * 2.1 pcm_block
 * --------------
 * pcm_block Ϣ,
 * 1. ָϢ, ָ  ָ.
 * 2. , ݱ,λõָ.
 */
struct pcm_block {
    struct pcm_block	*next_p;
    struct pcm_block	*upchannel_p;
    struct pcm_block	*downchannel_p;
    struct channel	*channel_p;	// block  channel

    int			pos;		//ڿ ŵ λ
    int			length;		//ݿЧݵĳ
#define BUF_LENGTH	5120

    UI8			data[BUF_LENGTH];
};

/* 2.2 channel
 * ------------
 * ָͨ,ем
 * 2. , ЯݵĲƵ,ǷϢ.
 */
struct channel {
    UI8			type;		// channel 
#define STREAM_CHANNEL	1
#define DEFINE_CHANNEL  2

    uint8_t		mono_stereo;
    uint8_t		sample_size;
    uint16_t		dsp_speed;

    GNode		*belong_node_p;	//  channel Ϊ stream block ʱ,ָ mc node
    struct mpstr	mp;		//
};

void snd_mixplay_do(void);
#endif
