#ifdef cplusplus
extern "C" {
#endif

#define COLOR_RA	0
#define	COLOR_RB	1
#define COLOR_GA	2
#define COLOR_GB	3
#define COLOR_BA	4
#define COLOR_BB	5
#define COLOR_AA	6
#define COLOR_AB	7





#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>



    typedef struct {
        char name[3];
        int32_t	     value;
    }
    Transform;




    int get_alpha(const char *name,double *value);
    int get_currentframe(const char *name,int *value);
    int get_droptarget(const char *name,char * buff,size_t length);
    int get_framesloaded(const char *name,int *value);
    int get_height(const char *name,double *value);

    char * get_parent(const char *name,char * buff,size_t length);
    int get_rotation(const char *name,double *value);
    char * get_target(const char *name,char * buff,size_t length);
    int get_totalframes(const char *name,int *value);
    char * get_url(const char *name,char * buff,size_t length);
    int get_visible(const char *name,int *value);
    int get_width(const char *name,double *value);
    int get_x(const char *name,double *value);
    int get_xmouse(const char *name,int *value);
    int get_xscale(const char *name,double* value);
    int get_y(const char *name,double *value);
    int get_ymouse(const char *name,int *value);
    int get_yscale(const char *name,double *value);

    int set_alpha(const char *name,const double value);
    int set_height(const char *name,const double value);
    int set_name(const char *name,const char *value);
    int set_rotation(const char *name,const double value);
    int set_visible(const char *name,const int value);
    int set_width(const char *name,const double value);
    int set_x(const char *name,const double value);
    int set_xmouse(const char *name,const int value);
    int set_xscale(const char *name,const double value);
    int set_y(const char *name,const double value);
    int set_ymouse(const char *name,const int value);
    int set_yscale(const char *name,const double value);

    int get_focusrect();
    int get_highquality();
    char *  get_quality();
    int get_soundbuftime();
    int set_focusrect(const int focus);
    int set_highquality(const int quality);
    int set_quality(const char * quality);
    int set_soundbuftime(const int buftime);

    /*-------------------------------------------------------------*/


    int getAscii();
    int getCode();
    int getKeyStat(const int keycode);


    /*============================================================*/

    int set_name(const char * oldname,const char * name);
    int find_MovieClip_onPool(const char *name);


    /*============================================================*/

    int MouseObject_Show();
    int MouseObject_Hide();




    /*=============================================================*/
    int set_ColorObject_Transform(const char * name,Transform * form);
    int get_ColorObject_Transform(const char * name,Transform * form);

    int set_ColorObject_RGB(const char *name,int32_t rgb);
    int get_ColorObject_RGB(const char *name,int32_t *rgb);



    /*=============================================================*/

    int MovieClip_AttachMovie(const char * name, const char * symbolIdentifier,const char *newName,int32_t depth);

    int MovieClip_DuplicateMovieClip(const char * name, const char *newName,int32_t depth);

    int MovieClip_GetBounds(const char * name,const char * target, int32_t *xMin, int32_t *xMax, int32_t *yMin, int32_t *yMax);

    int32_t MovieClip_GetBytesLoaded(const char *name);

    int32_t MovieClip_GetBytesTotal(const char *name);

    int MovieClip_GetURL(const char *name,const char * url,const char * window,const char *method);

    int MovieClip_GlobalToLocal(const char *name,double *x,double *y);

    int MovieClip_GotoAndPlay_Number(const char *name,int frameNumber);

    int MovieClip_GotoAndPlay_Label(const char *name,const char *frameLabel, const int Scene);

    int MovieClip_GotoAndStop_Number(const char *name,const int frameNumber);

    int MovieClip_GotoAndStop_Label(const char *name,const char *frameLabel, const int Scene);

    int MovieClip_HitTest_by_Object(const char *name,const char *tmpstr);

    int MovieClip_HitTest_by_Coordinate(const char *name,const int32_t x,const int32_t y,const int32_t shapeFlag);

    int MovieClip_LoadMovie(const char *name, const char *url, const char *method);

    int MovieClip_LoadVariables(const char *name,const char * url,const char *method);

    int MovieClip_LocalToGlobal(const char *name,double *x,double *y);

    int MovieClip_NextFrame(const char *name);

    int MovieClip_Play(const char *name);

    int MovieClip_PrevFrame(const char *name);

    int MovieClip_RemoveMovieClip(const char *name);


    int MovieClip_StartDrag(const char *name, int lockCenter, int32_t left, int32_t top, int32_t right, int32_t bottom);


    int MovieClip_Stop(const char *name);

    int MovieClip_StopDrag(const char *name);

    int MovieClip_SwapDepths_by_depth(const char *name,int depth);

    int MovieClip_SwapDepths_by_target(const char *name,const char *target);

    int MovieClip_UnloadMovie(const char *name);

    /*================================================================*/

    int MovieClip_Print(const char *target,const char *boundingBox);

    int MovieClip_Fscommand(const char *command,const char * arguments);

    int32_t MovieClip_GetTimer();

    int MovieClip_NextScene(const char *name);

    int MovieClip_PrevScene(const char *name);

    int MovieClip_PrintAsBitmapNum(const char *target,const char *boundingBox);

    int MovieClip_PrintAsBitmap(const char *target,const char *boundingBox);

    int MovieClip_PrintNum(const char * cname,const char * boundingBox);

    int MovieClip_StopAllSounds();

    int MovieClip_toggleHighQuality();

    int MovieClip_UpdateAfterEvent();


    int MovieClip_Call_Label(const char *target,const char *framename,unsigned char **framecode,int *codelen);

    int MovieClip_Call_Number(const char *target,int frameNum,unsigned char **framecode,int * codeleng);

    int MovieClip_IfFrameLoaded_Label(const char *target,const char *framename);

    int MovieClip_IfFrameLoaded_Number(const char *target,int frameNum);




    /*==================================================================*/


    int SoundObject_AttachSound(const char *pname,const char *soundname);


    int SoundObject_GetPan(const char *pname);


    int SoundObject_GetTransform(const char *pname,Transform * form);


    int SoundObject_GetVolume(const char *pname);


    int SoundObject_SetPan(const char *pname,int equilibria);


    int SoundObject_SetTransform(const char *pname,Transform * form);


    int SoundObject_SetVolume(const char *pname,int volume);


    int SoundObject_Start(const char *pname,double secondOffset,int loops);


    int SoundObject_Stop(const char *pname,const char *soundname);


    int SoundObject_GetPosition(const char *name);

    char *SoundObject_GetId3(const char *name);

    int SoundObject_GetDuration(const char *name);


    /*===================================================================*/

    int SelectionObject_GetBeginIndex();

    int SelectionObject_GetCaretIndex();

    int SelectionObject_GetEndIndex();

    int SelectionObject_GetFocus(char * focus,const int len); /* value-result function*/

    int SelectionObject_Setfocus(const char *focus);

    int SelectionObject_SetSelection(int beginIndex,int endIndex);



    /*==============================================================*/

    //int find_TextField_onPool(const char *name);

    int TextField_GetScroll(const char *name,int *value,int flags);

    int TextField_GetMaxScroll(const char *name,int *value,int flags);

    int TextField_SetScroll(const char *name,const int val,int flags);

    int TextField_SetMaxScroll(const char *name,const int val,int flags);

    char * TextField_GetBuffer(const char *name);

    int TextField_SetBuffer(const char *name,const char *buffer);

    int Get_rootname_onPool(char * buffer,size_t len);

    int MovieClip_GetVersion();

    int MovieClip_FindLabel(const char *target,const char *label);


#ifdef cplusplus
};
#endif

