#ifndef _BASE_TYPES_H_
#define _BASE_TYPES_H_
#include <glib.h>

#define UI8	unsigned char
#define UI16	unsigned short
#define UI32	unsigned long
#define SI8	char
#define SI16	short
#define SI32	long
#define UB_1	unsigned char
#define STRING	char*
#define FB	float

#define TWIPS_PER_POINT	20
//ηΧ
struct RECT     {
    long    	Xmin;
    long    	Xmax;
    long    	Ymin;
    long    	Ymax;
};

struct RGB     {
    UI8		Red;
    UI8   	Green;
    UI8   	Blue;
};

struct RGBA     {
    UI8		Red;
    UI8   	Green;
    UI8   	Blue;
    UI8   	Alpha;
    long	pixel;	// R+B+G+Alpha ֵ
};

//͸ȵɫתӷͳ˷
struct CxFormWithAlpha   {
    UB_1   	HasAddTerms;
    UB_1   	HasMultTerms;
    FB   	RedMultTerm;	// ˷
    FB   	GreenMultTerm;
    FB   	BlueMultTerm;
    FB   	AlphaMultTerm;
    long   	RedAddTerm;	// ӷ
    long   	GreenAddTerm;
    long   	BlueAddTerm;
    long   	AlphaAddTerm;
};

//ƶתƽ
struct Matrix {
    UB_1   	HasScale;	// 
    FB   	ScaleX;
    FB   	ScaleY;
    UB_1   	HasRotate;	// ת
    FB   	RotateSkew0;
    FB   	RotateSkew1;
    long   	TranslateX;	// ƶ
    long   	TranslateY;
};

struct GradRecord {
    UI8                 Ratio;
    struct RGBA         Color;
};

// ɫ
struct Gradient {
    UI8                 NumGradients;
    struct RGBA		*g_ramp;
    struct Matrix	imat;
    int                	g_has_alpha;
    struct GradRecord	GradientRecords[1];
};

// ActionScript P-Code 
struct ActionRecord {
    struct ActionRecord*        NextP;
    UI32                	Length;
    UI8                 	Code[1];
};
struct RGBA      BackgroundColor;

long mat_getx(struct Matrix *matrix_p,long x,long y) ;
long mat_gety(struct Matrix *matrix_p, long x, long y) ;
void mat_new(struct Matrix *matrix_p) ;
struct Matrix mat_multi(struct Matrix *n, struct Matrix *m) ;
struct Matrix mat_invert(struct Matrix *matrix_p) ;
struct RECT mat_multi_rect(struct Matrix *m_p, struct RECT *r_p);
gboolean rect_is_point_in(struct RECT *r_p, long x, long y);
gboolean rect_is_rect_cross(struct RECT *r1_p, struct RECT *r2_p);
struct RECT rect_add(struct RECT *r1_p, struct RECT *r2_p);
void rect_new(struct RECT *r_p);
void cxform_new(struct CxFormWithAlpha *cx_p);
#endif
