#include <glib.h>
#include <stdio.h>
#include "base_types.h"
#include "instance.h"
#include "player_pub.h"
#include "changed.h"

changed_t* chg_new(swf_file_t *swf_p) {
    changed_t	*changed_p = g_new0(changed_t,1);

    changed_p->swf_p = swf_p;
    return changed_p;
};

static gboolean chg_add_boundary_do(GNode* node_p,gpointer in_chg_p) {
    instance_t  *data_p = (instance_t*)(node_p->data);
    changed_t	*chg_p  = in_chg_p;

    chg_p->dirty_area = rect_add(&chg_p->dirty_area,&data_p->boundary);

    return FALSE;
};

void chg_add_boundary(changed_t *chg_p,GNode* node_p) {

    g_node_traverse(node_p,G_PRE_ORDER,G_TRAVERSE_LEAFS,-1,chg_add_boundary_do,chg_p);
};

void chg_reset_dirty_area(changed_t *chg_p) {
    chg_p->dirty_area.Xmin = LONG_MAX;
    chg_p->dirty_area.Xmax = LONG_MIN;
    chg_p->dirty_area.Ymin = LONG_MAX;
    chg_p->dirty_area.Ymax = LONG_MIN;
};

void chg_print_dirty_area(changed_t *chg_p) {
    printf("dirty arca %ld,%ld,%ld,%ld\n",
           chg_p->dirty_area.Xmin,
           chg_p->dirty_area.Xmax,
           chg_p->dirty_area.Ymin,
           chg_p->dirty_area.Ymax);
}
