#include <stdio.h>
#include <glib.h>
#include <assert.h>
#include "define.h"
#include "player_pub.h"
#include "base_types.h"
#include "instance.h"
#include "swf_file_pub.h"
#include "spliter_pub.h"
#include "render_pub.h"
#include "movie_clips_ins.h"
#include "movie_clips_def.h"
#include "button_ins.h"
#include "button_def.h"
#include "action.h"
#include "event.h"
#include "action_fortest.h"
#include "xwin_event.h"
#if WITH_DMALLOC
#include <dmalloc.h>
#endif

extern player_t      *player_p;
void event_dispatcher(void) {
    swf_file_t		*swf_p = player_p->_level0_p;
    GSList		*p;
    //    to_exec_t		to_exec;

    assert(pthread_mutex_lock(&player_p->eventq_mutex)==0);
    while (player_p->eventq_p) {
        //     to_exec.node_p = NULL;
        switch (((struct flash_event*)player_p->eventq_p->data)->event_type) {
        case EVENT_KEY_PRESS:
            event_key(player_p->eventq_p->data);
            break;
        case EVENT_BUTTON_RELEASE:
        case EVENT_BUTTON_PRESS:
        case EVENT_MOTION_NOTIFY:
            event_mouse(swf_p->_root_p,player_p->eventq_p->data);
            break;
        };
        /*
               if (to_exec.node_p) {
                   to_exec_t 	*a_p;
                   a_p = g_new0(to_exec_t,1);
                   *a_p = to_exec;
                   player_p->actionq_p = g_slist_append(player_p->actionq_p,a_p);
               };
        */
        p = player_p->eventq_p;
        player_p->eventq_p = g_slist_remove_link(player_p->eventq_p,p);
        free(p->data);
        g_slist_free_1(p);
    };
    //    printf("out event_dispatcher\n");
    assert(pthread_mutex_unlock(&player_p->eventq_mutex)==0);
};
