#ifndef _MORPHING_H_
#define _MORPHING_H_

#include "shape_def.h"

struct  MorphLineStyle  {
    UI16                        StartWidth;
    UI16                        EndWidth;
    struct RGBA                 StartColor;
    struct RGBA                 EndColor;
};

struct MorphLineStyleArray	{
    int			count;
    struct MorphLineStyle	MorphLineStyles[1];
};

struct  MorphGradRecord {
    struct  MorphGradRecord*	NextP;
    UI8                 	StartRatio;
    struct RGBA         	StartColor;
    UI8                 	EndRatio;
    struct RGBA         	EndColor;
};

struct MorphFillStyle   {
    UI8                         FillStyleType;
    struct RGBA                 StartColor;
    struct RGBA                 EndColor;
    struct Matrix               StartGradientMatrix;
    struct Matrix               EndGradientMatrix;
    struct MorphGradRecord*     GradientP;
    UI16                        BitmapId;
    struct Matrix               StartBitmapMatrix;
    struct Matrix               EndBitmapMatrix;
};

struct MorphFillStyleArray	{
    int			count;
    struct MorphFillStyle	MorphFillStyles[1];
};

//   4 
struct  DefineMorphShape        {
    UI8                 	CharacterType; // = CharMorphShape;
    UI16			CharacterID;
    struct RECT                 StartBounds;
    struct RECT                 EndBounds;
    struct MorphFillStyleArray*      MorphFillStylesP;
    struct MorphLineStyleArray*      MorphLineStylesP;
    struct ShapeRecord*        	StartEdgesP; //  StraightEdgeRecord,CurvedEdgeRecord
    struct ShapeRecord*        	EndEdgesP; //  StraightEdgeRecord,CurvedEdgeRecord
};
#endif
