#ifndef _SHAPES_H_
#define _SHAPES_H_
#include "base_types.h"

struct FillStyle        {
    UI8                         FillStyleType;
    struct RGBA                 Color;
    struct Matrix               GradientMatrix;
    struct Gradient             *GradientP;
    UI16                        BitmapId;
    struct Matrix               BitmapMatrix;
    struct RGBA               *cmap;
    unsigned char              *alpha_table;
};

struct FillStyleArray	{
    int			count;
    struct FillStyle	FillStyles[1];
};

struct LineStyle        {
    UI16                Width;
    struct RGBA         ColorRGB;
    struct RGBA         RendColor;
};

struct LineStyleArray	{
    int			count;
    struct LineStyle	LineStyles[1];
};

struct ShapeRecord	{
    struct ShapeRecord*	NextP;
    UI8			Flags;
};

// ֱ߼¼
struct StraightEdgeRecord {
    void*		NextP;
    UI8			Flags;
#define	TStraightEdge	0xc0

    UB_1                StraightLineFlag;
    long                StraightLineDeltaX;
    long                StraightLineDeltaY;
    UB_1                VertLineFlag;
    long                HorLineDeltaX;
    long                VertLineDeltaY;
};

// ߼¼
struct CurvedEdgeRecord {
    void*		NextP;
    UI8			Flags;
#define	TCurvedEdge	0x80

    long                ControlDeltaX;
    long                ControlDeltaY;
    long                AnchorDeltaX;
    long                AnchorDeltaY;
};

struct StyleChangeRecord        {
    void*			NextP;
    UI8				Flags;
#define StateNewStyles		0x1<<4
#define StateLineStyle		0x1<<3
#define StateFillStyle1		0x1<<2
#define StateFillStyle0 	0x1<<1
#define StateMoveTo		0x1<<0
    //    long                        MoveBits;
    long                        MoveDeltaX;
    long                        MoveDeltaY;
    long                        FillStyle0;
    long                        FillStyle1;
    long                        LineStyle;
    struct FillStyleArray*	FillStylesP;
    struct LineStyleArray*	LineStylesP;
    long                        NumFillBits;
    long                        NumLineBits;
};

// shape Ͻ, һΪ FillStyle , һΪ LineStyle
//   .
//  DefineShape, DefineShape2, DefineShape3;
struct DefineShape {
    UI8                 	CharacterType;// = CharShape;
    UI16			CharacterID;
    struct RECT			ShapeBounds;
    struct FillStyleArray*     	FillStylesP;
    struct LineStyleArray*     	LineStylesP;
    struct ShapeRecord*		ShapeRecordsP;	//  StraightEdgeRecord,CurvedEdgeRecord  StyleChangeRecord
};

#endif
