#ifndef _SOUND_DEF_H_
#define _SOUND_DEF_H_

#include "base_types.h"

// ʽͷ
struct SoundStreamHead  {
    UI8			PlaybackFlags;
    UI8			StreamSoundFlags;
#define Uncompressed	0x0
#define ADPCM		0x10
#define MP3		0x20
#define Uncompressed_le	0x30
#define Nellymoser	0x60

#define D5_5KH	0x0
#define D11KH	0x4
#define D22KH	0x8
#define D44KH	0xc

#define D8Bit	0x0
#define D16Bit	0x2

#define Mono	0x0
#define Stereo  0x1

    UI16                StreamSoundSampleCount;
    SI16                LatencySeek;
};

// XXX ʽӦΪ
struct SoundStreamBlock {
    struct MovieClip*	MovieClipP;
    UI16		Count;
    UI8                 StreamSoundData[1];
};
struct MP3StreamSoundData {
    UI16		SampleCount;
    SI16		SeekSamples;
    UI8			MP3Frames[0];
};

// ¼Ķ
struct DefineSound {
    UI8			CharacterType;// = CharEventSound;
    UI16                SoundId;
    UI8			SoundFlags;
    UI32                SoundSampleCount;
    UI32		SoundLength;
    UI8                 SoundData[1];
};
struct SoundEnvelope {
    UI32                        Pos44;
    UI16                        LeftLevel;
    UI16                        RightLevel;
};

// ¼Ĳ,ѭ,,ֹͣ
struct SoundInfo {
    UI8				Flags;
#define SyncStop	0x1<<5
#define SyncNoMultiple	0x1<<4
#define HasEnvelope	0x1<<3
#define HasLoops	0x1<<2
#define HasOutPoint	0x1<<1
#define HasInPoint	0x1<<0

    UI32                        InPoint;
    UI32                        OutPoint;
    UI16                        LoopCount;
    UI8                         EnvPoints;
    struct SoundEnvelope        EnvelopeRecords[1];
};


// ¼Ĳ,
struct  StartSound {
    struct  StartSound*	NextP;
    UI16                SoundId;
    struct SoundInfo*   SoundInfoP;
};

#endif
