#include <stdio.h>

#ifndef __bitio_h__
#define __bitio_h__

#define READER_TYPE_FILE 0
#define READER_TYPE_MEM  1
#define READER_TYPE_ZLIB 2

struct MovieClips {
    struct MovieClips *NextP;
    struct MovieClip *MovieClipP;
    int frame;
};

struct reader_t {
    int (*read)(struct reader_t*, void*data, int len);

    void *internal;
    int type;
    unsigned char mybyte;
    unsigned char bitpos;
    int pos;

    struct MovieClips 	*MovieClipsPointer;
};

void reader_resetbits(struct reader_t*r);
unsigned int reader_readbit(struct reader_t*r);
unsigned int reader_readbits(struct reader_t*r, int num);

/* standard readers / writers */

void reader_init_filereader(struct reader_t*r, int handle);
void reader_init_zlibinflate(struct reader_t*r, struct reader_t*input);
void reader_init_memreader(struct reader_t*r, void*data, int length);
#endif //__bitio_h__
