#ifndef _XWIN_PUB_H_
#define _XWIN_PUB_H_
#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>
#include <inttypes.h>
#include <X11/extensions/XShm.h>
#include <pthread.h>
#include <glib.h>
#include "player_pub.h"

typedef struct FlashDisplay {
    unsigned char* 	*pixels;
    unsigned char*      *pixels1;
    int 		bpl;      /* bytes per line */
    int 		width;
    int 		height;
    int 		depth;
    int 		bpp;
    int 		flash_refresh;
    /* Clipping region */
    int 		clip_x, clip_y;
    int 		clip_width, clip_height;
}
FlashDisplay;
typedef void (*ScanLineFunc)(void *id, long y, long start, long end);
typedef struct xwin {
    struct player 		*player_p;

    pthread_mutex_t         	win_mutex;
    int16_t			win_ox, win_oy;		// movie ԭ  ԭ 
    int16_t			win_x, win_y;
    uint16_t			win_width,win_height;
    uint8_t			win_visable;
    uint8_t			win_dirty;
    float			twips_per_pixel;
    gboolean			win_destory;		//  pipe_cmd ܵյĹرմϢ

    FlashDisplay 		fd;
    Display			*dpy;		// X11 Display
    Window			movie;		// Target window
    GC		 	 	gc;		// X11 Graphic context
    Pixmap			canvas;		// Graphic buffer
    XShmSegmentInfo		segInfo;
}
xwin_t;

extern pthread_mutex_t         	xwin_mutex;

xwin_t* xwin_new(struct player *player_p);
void xwin_draw_frame(xwin_t *xwin_p,int all);
void xwin_move_position(xwin_t *xwin_p);
void xwin_destory(xwin_t *xwin_p);
#endif
